﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MediaItemContract;
using System.Windows.Threading;

namespace ChatItem
{
    public class ChatItem: IArtifactItem
    {
        ChatIconItem icon;
        ChatThumbnailItem thumbnail;
        ChatInteractionItem interaction;
        public ChatHistory chatHistory;
        public IPerson currentPerson;

        #region IArtifactItem Members

        public static bool AcceptDropFormat(System.Windows.IDataObject data)
        {
            return false;
        }

        public void DropData(System.Windows.IDataObject data)
        {
            
        }

        public void StartItem(GroupLab.Networking.SharedDictionary sd, string path, object obj, IArtifact artifactHelper, IPerson personHelper)
        {
            this.currentPerson = personHelper;
            this.chatHistory = new ChatHistory(sd, path, currentPerson, Dispatcher.CurrentDispatcher);
            this.icon = new ChatIconItem(chatHistory);
            this.thumbnail = new ChatThumbnailItem(chatHistory);
            this.interaction = new ChatInteractionItem(chatHistory);
        }

        public void StopItem()
        {
            
        }

        #endregion

        #region IItem Members

        /*public void AttachedToContainer()
        {
            
        }

        public void AttachedToOverlay()
        {
            
        }*/

        public System.Windows.Controls.UserControl GetIconItem()
        {
            return icon;
        }

        public System.Windows.Controls.UserControl GetInteractionItem()
        {
            return interaction;
        }

        public System.Windows.Controls.UserControl GetThumbnailItem()
        {
            return thumbnail;
        }

        /*public void LeaveInteractionMode()
        {
            
        }

        public void MovingInOverlay()
        {
            
        }

        public void TeBeDetachedFromOverlay()
        {
            
        }

        public void ToBeAttachedToContainer()
        {
            
        }

        public void ToBeAttachedToOverlay()
        {
            
        }

        public void ToBeDetachedFromContainer()
        {
            
        }*/

        #endregion

        #region ICloneable Members

        public object Clone()
        {
            ChatItem item = new ChatItem();
            //item.Initialize(this.person);
            item.chatHistory = this.chatHistory;
            item.icon = new ChatIconItem(chatHistory);
            item.thumbnail = new ChatThumbnailItem(chatHistory);
            item.interaction = new ChatInteractionItem(chatHistory);
            return item;
        }

        #endregion

        public static string ItemName
        {
            get { return "Chat"; }
        }
    }
}
