﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GroupLab.Networking;

namespace MediaItemContract
{
    public class ArtifactContractHelper : LocaleMember, IArtifact
    {
        public string Name { get; set; }
        public string ArtifactGuid { get; set; }
        public string OwnerGuid { get; set; }

        Subscription artifactSub;
        public ArtifactContractHelper(SharedDictionary sd, string guid)
            : base(sd, "/artifacts/" + guid)
        {
            this.ArtifactGuid = guid;
            this.artifactSub = new Subscription();
            this.artifactSub.BeginInit();
            this.artifactSub.Dictionary = this.sd;
            this.artifactSub.Pattern = this.path;
            this.artifactSub.Notified += new SubscriptionEventHandler(artifactSub_Notified);
            this.artifactSub.EndInit();
        }

        void artifactSub_Notified(object sender, SubscriptionEventArgs e)
        {
            if (e.Reason == SubscriptionNotification.Add)
            {
                Map map = e.Value as Map;
                //this.Name = map["name"] as string;
                this.ArtifactGuid = map["guid"] as string;
                OnPropertyChanged("ArtifactGuid");
            }
            else if (e.Reason == SubscriptionNotification.Change)
            {
                Map map = e.Value as Map;
                //this.Name = map["name"] as string;
                this.ArtifactGuid = map["guid"] as string;
                OnPropertyChanged("ArtifactGuid");
            }
        }
    }
}
