﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using GroupLab.Networking;

namespace MediaItemContract
{
    public abstract class LocaleMember : INotifyPropertyChanged
    {
        public string path { get; set; }
        public SharedDictionary sd;

        public LocaleMember(SharedDictionary sd, string path)
        {
            this.sd = sd;
            this.path = path;
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(
                this, new PropertyChangedEventArgs(propertyName)
                );
            }
        }

        #endregion
    }
}
