﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MediaItemContract;
using System.Windows;
using System.IO;

namespace PhotoItem
{
    public class PhotoMediaItem: IArtifactItem
    {
        PhotoIconItem icon;
        PhotoThumbnailItem thumbnail;
        PhotoInteractionItem interaction;
        Photos photos;
        #region IArtifactItem Members

        public static bool AcceptDropFormat(System.Windows.IDataObject data)
        {
            return data.GetDataPresent(DataFormats.FileDrop);
        }

        public void DropData(System.Windows.IDataObject data)
        {
            if (data.GetDataPresent(DataFormats.FileDrop))
            {
                string[] droppedFilePaths = data.GetData(DataFormats.FileDrop) as string[];
                LoadPhotos(droppedFilePaths);
            }
        }

        public void LoadPhotos(string[] photoFilePaths)
        {
            foreach (string photoFilePath in photoFilePaths)
            {
                Console.WriteLine(photoFilePath);
                if (File.Exists(photoFilePath))
                {
                    photos.UpdatePhoto(photoFilePath);
                }
                //Path
                //Directory
                //FileInfo photoObj = new FileInfo(droppedFilePath);
                //photoObj.di
                //DirectoryInfo
                //photos.UpdatePhoto(droppedFilePath);
                break;
            }
        }

        public void StartItem(GroupLab.Networking.SharedDictionary sd, string path, object obj, IArtifact artifactHelper, IPerson personHelper)
        {
            this.photos = new Photos(sd, path);
            this.icon = new PhotoIconItem();
            this.thumbnail = new PhotoThumbnailItem(this.photos);
            this.interaction = new PhotoInteractionItem(this.photos);
            if (obj != null)
            {
                DropData(obj as IDataObject);
            }
        }

        public void StopItem()
        {
            
        }

        #endregion

        #region IItem Members

        public System.Windows.Controls.UserControl GetIconItem()
        {
            return icon;
        }

        public System.Windows.Controls.UserControl GetInteractionItem()
        {
            return interaction;
        }

        public System.Windows.Controls.UserControl GetThumbnailItem()
        {
            return thumbnail;
        }

        #endregion

        #region ICloneable Members

        public object Clone()
        {
            PhotoMediaItem item = new PhotoMediaItem();
            item.photos = this.photos;
            item.icon = new PhotoIconItem();
            item.thumbnail = new PhotoThumbnailItem(item.photos);
            item.interaction = new PhotoInteractionItem(item.photos);
            return item;
        }

        #endregion

        public static string ItemName
        {
            get { return "Photo"; }
        }
    }
}
