﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MediaItemContract;
using System.Windows.Media;
using GroupLab.Networking;
using System.Windows.Media.Imaging;
using System.IO;

namespace PhotoItem
{
    public class Photos: AbstractArtifact
    {
        public ImageSource IconSource { get; set; }
        public ImageSource ThumbnailSource { get; set; }
        public ImageSource ImageSource { get; set; }

        public Subscription imagesSub;
        private object imgLock = "image processing lock";

        public Photos(SharedDictionary sd, string path):base(sd,path)
        {
            this.ThumbnailSource = new BitmapImage(new Uri("images/picture.png", UriKind.Relative));
            this.ImageSource = new BitmapImage(new Uri("images/files_image.png", UriKind.Relative));
            //Console.WriteLine("setup images");
            this.imagesSub = new Subscription();
            this.imagesSub.BeginInit();
            this.imagesSub.Dictionary = this.sd;
            this.imagesSub.Pattern = path + "/images";
            this.imagesSub.Notified += new SubscriptionEventHandler(imagesSub_Notified);
            this.imagesSub.EndInit();
        }

        void imagesSub_Notified(object sender, SubscriptionEventArgs e)
        {
            lock (imgLock)
            {
                MemoryStream stream = e.Value as MemoryStream;
                stream.Seek(0, SeekOrigin.Begin);
                JpegBitmapDecoder decoder = new JpegBitmapDecoder(stream, BitmapCreateOptions.PreservePixelFormat, BitmapCacheOption.OnLoad);
                BitmapSource image = decoder.Frames[0];
                //iconSource = image;
                //stream.Seek(0, SeekOrigin.Begin);
                this.ImageSource = image;
                //stream.Seek(0, SeekOrigin.Begin);
                OnPropertyChanged("ImageSource");
                //stream.Seek(0, SeekOrigin.Begin);
                this.ThumbnailSource = image;
                //stream.Seek(0, SeekOrigin.Begin);
                OnPropertyChanged("ThumbnailSource");
                //stream.Seek(0, SeekOrigin.Begin);
                
            }
        }

        public void UpdateImage(BitmapSource image)
        {
            MemoryStream stream = new MemoryStream();
            JpegBitmapEncoder encoder = new JpegBitmapEncoder();
            //encoder.FlipVertical = true;
            encoder.QualityLevel = 30;
            encoder.Frames.Add(BitmapFrame.Create(image));
            encoder.Save(stream);
            //stream.Seek(0, SeekOrigin.Begin);
            //this.sd[People.peoplePath + this.guid + "/image"] = stream.ToArray();
            this.sd[path + "/images"] = stream;
            //this.sd[People.peoplePath + this.guid + "/image.unreliable"] = "true";
            //stream.Dispose();
        }

        public void UpdatePhoto(string file)
        {
            //this.ImageSource = new BitmapImage(new Uri(file));
            UpdateImage(new BitmapImage(new Uri(file)));
            //OnPropertyChanged("ImageSource");
        }

    }
}
