﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MediaItemContract;

namespace PresenceItem
{
    public class PresenceItem: IPersonItem
    {
        PresenceIconItem icon;
        PresenceThumbnailItem thumbnail;
        PresenceInteractionItem interactive;
        public Presence presence;
        public PresenceItem()
        {

        }

        #region IItem Members

        public System.Windows.Controls.UserControl GetIconItem()
        {
            return icon;
        }

        public System.Windows.Controls.UserControl GetThumbnailItem()
        {
            return thumbnail;
        }

        public System.Windows.Controls.UserControl GetInteractionItem()
        {
            return interactive;
        }

        /*public void ToBeDetachedFromContainer()
        {

        }

        public void ToBeAttachedToOverlay()
        {

        }

        public void AttachedToOverlay()
        {

        }

        public void TeBeDetachedFromOverlay()
        {

        }

        public void ToBeAttachedToContainer()
        {

        }

        public void AttachedToContainer()
        {

        }

        public void MovingInOverlay()
        {

        }

        public void LeaveInteractionMode()
        {

        }*/

        #endregion

        #region ICloneable Members

        public object Clone()
        {
            PresenceItem item = new PresenceItem();
            //item.Initialize(this.person);
            item.presence = this.presence;
            item.icon = new PresenceIconItem(presence);
            item.thumbnail = new PresenceThumbnailItem(presence);
            item.interactive = new PresenceInteractionItem(presence);
            return item;
        }

        #endregion

        #region IPersonItem Members

        /*Person person
        {
            get
            {
                return presence;
            }
            set
            {
                if (value is Presence)
                {
                    presence = value as Presence;
                }
                else
                {
                    presence = new Presence(value);
                }
            }
        }

        public void Initialize(Person person)
        {
            this.person = person;
            icon = new PresenceIconItem(presence);
            thumbnail = new PresenceThumbnailItem(presence);
            interactive = new PresenceInteractionItem(presence);
        }*/

        public void StartItem(GroupLab.Networking.SharedDictionary sd, string path, IPerson personHelper)
        {
            this.presence = new Presence(sd, path);
            this.presence.person = personHelper;
            icon = new PresenceIconItem(presence);
            thumbnail = new PresenceThumbnailItem(presence);
            interactive = new PresenceInteractionItem(presence);
        }

        public void StopItem()
        {
            
        }

        #endregion

        public static string ItemName
        {
            get { return "Presence"; }
        }

    }
}
