﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GroupLab.Networking;
using MediaItemContract;

namespace UIDemo
{
    public class Artifact: LocaleMember
    {
        Subscription artifactSub;
        public Artifact(SharedDictionary sd, string guid, Plugin plugin)
            : base(sd, guid, plugin)
        {
            this.artifactSub = new Subscription();
            this.artifactSub.BeginInit();
            this.artifactSub.Dictionary = this.sd;
            this.artifactSub.Pattern = Artifacts.artifactsPath + this.guid;
            this.artifactSub.Notified += new SubscriptionEventHandler(artifactSub_Notified);
            this.artifactSub.EndInit();
        }

        void artifactSub_Notified(object sender, SubscriptionEventArgs e)
        {
            if (e.Reason == SubscriptionNotification.Add)
            {
                Map map = e.Value as Map;
                //this.Name = map["name"] as string;
                /*if (this.plugin == null)
                {
                    string pluginID = map["item"] as string;
                    this.plugin = Account.singleton.itemLoader.FindArtifactPlugin(pluginID);
                    OnPropertyChanged("plugin");
                }*/
            }
            else if (e.Reason == SubscriptionNotification.Change)
            {
                Map map = e.Value as Map;
                //this.Name = map["name"] as string;
                /*if (this.plugin == null)
                {
                    string pluginID = map["item"] as string;
                    this.plugin = Account.singleton.itemLoader.FindArtifactPlugin(pluginID);
                    OnPropertyChanged("plugin");
                }*/
            }
        }

        public Artifact(string guid, Plugin plugin)
            : base(guid, plugin)
        {
            this.artifactSub = new Subscription();
            this.artifactSub.BeginInit();
            this.artifactSub.Dictionary = this.sd;
            this.artifactSub.Pattern = Artifacts.artifactsPath + this.guid;
            this.artifactSub.Notified += new SubscriptionEventHandler(artifactSub_Notified);
            this.artifactSub.EndInit();
        }

        public override MediaItem createMediaItem()
        {
            /*IArtifactItem artifactItem = this.plugin.CreatePlugin() as IArtifactItem;
            PersonHelper personHelper = new PersonHelper(Account.singleton.sd, Account.singleton.guid);
            artifactItem.StartItem(this.sd, Artifacts.artifactsPath + this.guid, null, personHelper);
            MediaItem mediaItem = new MediaItem(artifactItem, this);
            mediaItem.Width = 64;
            mediaItem.Height = 64;*/
            MediaItem mediaItem = new MediaItem(this);
            return mediaItem;
        }

        public override IItem createPluginItem()
        {
            IArtifactItem artifactItem = this.plugin.CreatePlugin() as IArtifactItem;
            ArtifactContractHelper artifactHelper = new ArtifactContractHelper(this.sd, this.guid);
            PersonContractHelper personHelper = new PersonContractHelper(Account.singleton.sd, Account.singleton.guid);
            artifactItem.StartItem(this.sd, Artifacts.artifactsPath + this.guid, null, artifactHelper, personHelper);
            return artifactItem;
        }
    }
}
