﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace UIDemo
{
    /// <summary>
    /// Interaction logic for DockStation.xaml
    /// </summary>
    public partial class DockStation : Window
    {
        //public bool isPreviewVisible;
        public PreviewDock preview;
        public GlobalDefinition.PreDockState previewState;
        public GlobalDefinition.DockOrienation orientation;
        //public double topLine;
        public double dockPivot;
        public double dockLeft;
        public double dockRight;
        public int insertIndex;
        public DockStation()
        {
            InitializeComponent();
            preview = new PreviewDock();
            previewState = GlobalDefinition.PreDockState.NotPresent;
        }

        public void ShowPreviewDock(double pivot, double left, double right)
        {
            for (int i = 0; i < this.dock.Children.Count; i++)
            {
                UserControl element = this.dock.Children[i] as UserControl;
                Point point = element.PointToScreen(new Point(0, 0));
                double start = point.X;
                //double span = element.ActualWidth;
                preview.Top = this.Top;
                if (this.orientation == GlobalDefinition.DockOrienation.Right)
                {
                    start = point.Y;
                    //span = element
                    preview.Left = this.Left + this.ActualWidth - preview.bar.Height;
                }
                if (pivot >= start && pivot <= start + element.ActualWidth)
                {
                    preview.bar.Width = left + right;
                    //preview.Top = 0;
                    if (this.dock.Children[i] is PlaceHolder)
                    {
                        if (this.orientation == GlobalDefinition.DockOrienation.Right)
                        {
                            preview.Top = pivot - left;
                        }
                        else
                        {
                            preview.Left = pivot - left;
                        }
                        this.previewState = GlobalDefinition.PreDockState.Insert;
                        this.dockPivot = pivot - start;
                        this.dockLeft = left;
                        this.dockRight = right;
                        this.insertIndex = i;
                        //Console.WriteLine("place holder");
                    }
                    else
                    {
                        if (pivot < start + element.ActualWidth / 2)
                        {
                            //Console.WriteLine("left");
                            if (this.orientation == GlobalDefinition.DockOrienation.Right)
                            {
                                preview.Top = start - preview.bar.Width;
                            }
                            else
                            {
                                preview.Left = start - preview.bar.Width;
                            }

                            this.previewState = GlobalDefinition.PreDockState.Left;
                            this.insertIndex = i;
                        }
                        else
                        {
                            //Console.WriteLine("right");
                            if (this.orientation == GlobalDefinition.DockOrienation.Right)
                            {
                                preview.Top = start + element.ActualWidth;
                            }
                            else
                            {
                                preview.Left = start + element.ActualWidth;
                            }

                            this.previewState = GlobalDefinition.PreDockState.Right;
                            this.insertIndex = i;
                        }
                        //Console.WriteLine("dock");
                    }
                    preview.Show();
                    break;
                }
            }
        }

        public void HidePreviewDock()
        {
            preview.Hide();
            previewState = GlobalDefinition.PreDockState.NotPresent;
        }

        public void InsertIn(DockContainer newDock)
        {
            //Console.WriteLine(preview);
            PlaceHolder placeHolder = this.dock.Children[insertIndex] as PlaceHolder;
            double newPlaceHolderWidth = placeHolder.Width - dockPivot;
            placeHolder.Width = dockPivot;
            newDock.Width = 0;
            this.dock.Children.Insert(insertIndex + 1, newDock);
            PlaceHolder newPlaceHolder = new PlaceHolder(this);
            newPlaceHolder.Width = newPlaceHolderWidth;
            newPlaceHolder.VerticalAlignment = VerticalAlignment.Top;
            this.dock.Children.Insert(insertIndex + 2, newPlaceHolder);
            newDock.ExpandToLeft(dockLeft);
            newDock.ExpandToRight(dockRight);
        }

        public void AttachToFront(DockContainer newDock)
        {
            //PlaceHolder placeHolder = this.dock.Children[index-1] as PlaceHolder;
            double width = newDock.Width;
            newDock.Width = 0;
            UserControl frontDock = this.dock.Children[insertIndex - 1] as UserControl;
            /*if (frontDock is DockContainer)
            {
                newDock.dock.joinState = GlobalDefinition.DockJoinState.Both;
            }
            else
            {
                newDock.dock.joinState = GlobalDefinition.DockJoinState.Right;
                //DockContainer currentDock = this.dock.Children[insertIndex] as DockContainer;
                //currentDock.dock.joinState = GlobalDefinition.DockJoinState.Left;
                //currentDock.dock.UpdateDimensions();
            }*/
            newDock.dock.joinState |= Dock.DockJoinState.Right;
            if (frontDock is DockContainer)
            {
                newDock.dock.joinState |= Dock.DockJoinState.Left;
            }
            DockContainer rearDock = this.dock.Children[insertIndex] as DockContainer;
            /*if (rearDock.dock.joinState != GlobalDefinition.DockJoinState.Left && rearDock.dock.joinState != GlobalDefinition.DockJoinState.Both)
            {
                if (rearDock.dock.joinState == GlobalDefinition.DockJoinState.Right)
                {
                    rearDock.dock.joinState = GlobalDefinition.DockJoinState.Both;
                }
                else
                {
                    rearDock.dock.joinState = GlobalDefinition.DockJoinState.Left;
                }
                rearDock.dock.UpdateDimensions();
            }*/
            rearDock.dock.joinState |= Dock.DockJoinState.Left;
            rearDock.dock.UpdateDimensions();
            this.dock.Children.Insert(insertIndex, newDock);
            newDock.ExpandToLeft(width);
            //Console.WriteLine("expand to left by " + width);
            //newDock.dock.UpdateDimensions();
        }

        public void AttachToRear(DockContainer newDock)
        {
            //PlaceHolder placeHolder = this.dock.Children[index-1] as PlaceHolder;
            double width = newDock.Width;
            newDock.Width = 0;
            UserControl rearDock = this.dock.Children[insertIndex + 1] as UserControl;
            /*if (rearDock is DockContainer)
            {
                newDock.dock.joinState = GlobalDefinition.DockJoinState.Both;
            }
            else
            {
                newDock.dock.joinState = GlobalDefinition.DockJoinState.Left;
                //DockContainer currentDock = this.dock.Children[insertIndex] as DockContainer;
                //currentDock.dock.joinState = GlobalDefinition.DockJoinState.Left;
                //currentDock.dock.UpdateDimensions();
            }*/
            newDock.dock.joinState |= Dock.DockJoinState.Left;
            if (rearDock is DockContainer)
            {
                newDock.dock.joinState |= Dock.DockJoinState.Right;
            }
            DockContainer frontDock = this.dock.Children[insertIndex] as DockContainer;
            /*if (frontDock.dock.joinState != GlobalDefinition.DockJoinState.Right && frontDock.dock.joinState != GlobalDefinition.DockJoinState.Both)
            {
                if (frontDock.dock.joinState == GlobalDefinition.DockJoinState.Left)
                {
                    frontDock.dock.joinState = GlobalDefinition.DockJoinState.Both;
                }
                else
                {
                    frontDock.dock.joinState = GlobalDefinition.DockJoinState.Right;
                }
                frontDock.dock.UpdateDimensions();
            }*/
            frontDock.dock.joinState |= Dock.DockJoinState.Right;
            frontDock.dock.UpdateDimensions();
            this.dock.Children.Insert(insertIndex + 1, newDock);
            newDock.ExpandToRight(width);
        }

        public void Remove(DockContainer dock)
        {
            int index = this.dock.Children.IndexOf(dock);
            UserControl frontDock = this.dock.Children[index - 1] as UserControl;
            UserControl rearDock = this.dock.Children[index + 1] as UserControl;
            double overRun = GetOverRun();
            if (frontDock is PlaceHolder && rearDock is PlaceHolder)
            {
                double right = dock.ActualWidth + rearDock.ActualWidth;
                this.dock.Children.RemoveRange(index, 2);
                if (overRun > right)
                {
                    right = 0;
                }
                else
                {
                    right -= overRun;
                }
                frontDock.Width += right;
            }
            else if (frontDock is PlaceHolder)
            {
                double right = dock.ActualWidth;
                /*if (((DockContainer)rearDock).dock.joinState == GlobalDefinition.DockJoinState.Both)
                {
                    ((DockContainer)rearDock).dock.joinState = GlobalDefinition.DockJoinState.Right;
                }
                else
                {
                    ((DockContainer)rearDock).dock.joinState = GlobalDefinition.DockJoinState.None;
                }*/
                ((DockContainer)rearDock).dock.joinState &= ~Dock.DockJoinState.Left;
                ((DockContainer)rearDock).dock.UpdateDimensions();
                this.dock.Children.RemoveAt(index);
                if (overRun > right)
                {
                    right = 0;
                }
                else
                {
                    right -= overRun;
                }
                frontDock.Width += right;
                
            }
            else
            {
                if (rearDock is PlaceHolder)
                {
                    /*if (((DockContainer)frontDock).dock.joinState == GlobalDefinition.DockJoinState.Both)
                    {
                        ((DockContainer)frontDock).dock.joinState = GlobalDefinition.DockJoinState.Left;
                    }
                    else
                    {
                        ((DockContainer)frontDock).dock.joinState = GlobalDefinition.DockJoinState.None;
                    }*/
                    ((DockContainer)frontDock).dock.joinState &= ~Dock.DockJoinState.Right;
                    ((DockContainer)frontDock).dock.UpdateDimensions();
                }

                for (int i = 2; rearDock is DockContainer; i++)
                {
                    rearDock = this.dock.Children[index + i] as UserControl;
                }
                double right = dock.ActualWidth;
                this.dock.Children.RemoveAt(index);
                if (overRun > right)
                {
                    right = 0;
                }
                else
                {
                    right -= overRun;
                }
                rearDock.Width += right;
            }
        }

        public void Insert(DockContainer newDock)
        {
            //newDock.VerticalAlignment = VerticalAlignment.Stretch;
            if (this.previewState == GlobalDefinition.PreDockState.Insert)
            {
                InsertIn(newDock);
            }
            else if (this.previewState == GlobalDefinition.PreDockState.Left)
            {
                AttachToFront(newDock);
            }
            else if (this.previewState == GlobalDefinition.PreDockState.Right)
            {
                AttachToRear(newDock);
            }
            HidePreviewDock();
        }

        public void TransformDockToRight()
        {
            TransformGroup transformGroup = new TransformGroup();
            RotateTransform rotateTransform = new RotateTransform(90);
            transformGroup.Children.Add(rotateTransform);

            this.container.LayoutTransform = transformGroup;
            this.preview.bar.LayoutTransform = transformGroup;
            this.orientation = GlobalDefinition.DockOrienation.Right;
            /*foreach (MediaItem item in dock.iconPanel.Children)
            {
                TransformMediaItemToRight(item);
            }

            foreach (MediaItem item in dock.thumbnailPanel.Children)
            {
                TransformMediaItemToRight(item);
            }*/
        }

        public bool HitTest(Point point)
        {
            if (this.orientation == GlobalDefinition.DockOrienation.Right)
            {
                if (point.X >= this.ActualWidth - GlobalDefinition.detachingGap)
                {
                    return true;
                }
                return false;
            }
            else
            {
                if (point.Y <= GlobalDefinition.detachingGap)
                {
                    return true;
                }
                return false;
            }
        }

        public double GetOverRun()
        {
            Console.WriteLine("Dock width " + dock.ActualWidth);
            Console.WriteLine("OverRun " + (dock.ActualWidth - (this.container.ActualWidth - 4)));
            return dock.ActualWidth - (this.container.ActualWidth - 4);
        }
    }
}
