﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Windows;
using System.Threading;
using System.Windows.Input;

namespace UIDemo
{
    public static class GlobalDefinition
    {
        //public static DockStation topDock;
        public enum PreDockState
        {
            Insert,
            Left,
            Right,
            NotPresent
        }

        public enum DockOrienation
        {
            Top,
            Bottom,
            Left,
            Right
        }

        public enum DockJoinState
        {
            Left,
            Right,
            Both,
            None
        }

        public static ArrayList ScreenDockList;
        public static double dockingGap = 80;
        public static double detachingGap = 20;

        public static void SetupDockStations()
        {
            ScreenDockList = new ArrayList();
            System.Windows.Forms.Screen[] screens = System.Windows.Forms.Screen.AllScreens;
            int leftDockIndex = -1;
            int rightDockIndex = -1;
            double leftMost = 1;
            double rightMost = 0;
            for (int i = 0; i < screens.Length; i++)
            {
                /*ArrayList dockList = new ArrayList();
                TopDock topDock = new TopDock();
                topDock.Width = screens[i].WorkingArea.Width - 160;
                //topDock position and transform
                dockList.Add(topDock);
                if (screens[i].WorkingArea.Height == screens[i].Bounds.Height)
                {
                    TopDock bottomDock = new TopDock();
                    topDock.Width = screens[i].WorkingArea.Width - 160;
                    //topDock position and transform
                    dockList.Add(topDock);
                }*/
                if (screens[i].WorkingArea.Left < leftMost)
                {
                    leftDockIndex = i;
                    leftMost = screens[i].WorkingArea.Left;
                }
                if (screens[i].WorkingArea.Right > rightMost)
                {
                    rightDockIndex = i;
                    rightMost = screens[i].WorkingArea.Right;
                }
            }
            Console.WriteLine("Left Dock is on monitor " + leftDockIndex);
            Console.WriteLine("Right Dock is on monitor " + rightDockIndex);
            DockStation rightDock = new DockStation();
            PlaceHolder placeHolder = new PlaceHolder(rightDock);
            placeHolder.VerticalAlignment = VerticalAlignment.Stretch;
            rightDock.dock.Children.Add(placeHolder);
            rightDock.container.Width = screens[rightDockIndex].WorkingArea.Height;
            placeHolder.Width = rightDock.container.Width - 4;
            rightDock.Top = screens[rightDockIndex].WorkingArea.Top;
            rightDock.Left = screens[rightDockIndex].WorkingArea.Right - 150;
            rightDock.TransformDockToRight();
            //rightDock.topLine = screens[rightDockIndex].WorkingArea.Right;
            rightDock.Show();
            for (int i = 0; i < screens.Length; i++)
            {
                ArrayList dockList = new ArrayList();
                if (screens[i].WorkingArea.Top == screens[i].Bounds.Top)
                {
                    Console.WriteLine("monitor " + i + " has a top dock");
                    DockStation topDock = new DockStation();
                    PlaceHolder ph = new PlaceHolder(rightDock);
                    ph.VerticalAlignment = VerticalAlignment.Stretch;
                    topDock.dock.Children.Add(ph);
                    topDock.container.Width = screens[i].WorkingArea.Width;
                    ph.Width = topDock.container.Width - 4;
                    topDock.Top = screens[i].WorkingArea.Top;
                    topDock.Left = screens[i].WorkingArea.Left;
                    topDock.orientation = DockOrienation.Top;
                    //topDock.topLine = topDock.Top;
                    if (i == leftDockIndex)
                    {
                        Console.WriteLine("monitor " + i + " has a left dock too");

                    }
                    if (i == rightDockIndex)
                    {
                        Console.WriteLine("monitor " + i + " has a right dock too");
                        topDock.container.Width -= rightDock.ActualWidth;
                        ph.Width -= rightDock.ActualWidth;
                    }
                    topDock.Show();
                    dockList.Add(topDock);
                }
                /*if (screens[i].WorkingArea.Bottom == screens[i].Bounds.Bottom)
                {
                    Console.WriteLine("monitor " + i + " has a bottom dock");
                    if (i == leftDockIndex)
                    {
                        Console.WriteLine("monitor " + i + " has a left dock too");

                    }
                    if (i == rightDockIndex)
                    {
                        Console.WriteLine("monitor " + i + " has a right dock too");
                    }
                }*/
                ScreenDockList.Add(dockList);
            }
            ((ArrayList)ScreenDockList[rightDockIndex]).Add(rightDock);

        }

        public static DockStation DockStationHitTest(double top, double bottom, double left, double right)
        {
            foreach (ArrayList dockList in ScreenDockList)
            {
                foreach (DockStation dockStation in dockList)
                {
                    if (dockStation.orientation == DockOrienation.Top)
                    {
                        double dockBottom = dockStation.Top + dockingGap;
                        double dockLeft = dockStation.Left;
                        double dockRight = dockStation.Left + dockStation.Width;
                        //Console.WriteLine(bottom + " " + dockBottom);
                        if (top < dockBottom && (right > dockLeft || left < dockRight))
                        {
                            //Console.WriteLine("top");
                            return dockStation;
                        }
                    }
                    else if (dockStation.orientation == DockOrienation.Right)
                    {
                        double dockLeft = dockStation.Left + (dockStation.ActualWidth - dockingGap);

                        //Console.WriteLine(right + " " + dockLeft);
                        if (right > dockLeft)
                        {
                            //Console.WriteLine("right");
                            return dockStation;
                        }
                    }
                }
            }
            return null;
        }

        private delegate void MethodInvoker();

        public static void Focus(UIElement element)
        {
            //Focus in a callback to run on another thread, ensuring the main UI thread is initialized by the
            //time focus is set
            ThreadPool.QueueUserWorkItem(delegate(Object foo)
            {
                UIElement elem = (UIElement)foo;
                elem.Dispatcher.Invoke(System.Windows.Threading.DispatcherPriority.Normal,
                    (MethodInvoker)delegate()
                    {
                        elem.Focus();
                        Keyboard.Focus(elem);
                    });
            }, element);
        }

    }
}
