﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Animation;
using GroupLab.Networking;

namespace UIDemo
{
    public class GlobalVariables
    {
        public static ArrayList windowList;
        //public static TransientBorderWindow borderWindow;
        //static ArrayList overlappedWindowList;
        //public static ArrayList topDockList;

        public enum DockOrientation
        {
            Top,
            Bottom,
            Left,
            Right
        }

        /*public static ArrayList GetOverlappedWindows(Window window)
        {
            ArrayList overlappedWindows = new ArrayList();
            Rect rect = window.RestoreBounds;
            foreach (ItemWindow itemWindow in windowList)
            {
                if (itemWindow == window)
                {
                    continue;
                }
                Rect windowRect = itemWindow.RestoreBounds;
                if (rect.IntersectsWith(windowRect))
                {
                    overlappedWindows.Add(itemWindow);
                }
            }
            return overlappedWindows;
        }

        public static Rect GetUnionRect(ArrayList list, Window window)
        {
            Rect union = window.RestoreBounds;
            foreach (ItemWindow itemWindow in list)
            {
                Rect windowRect = itemWindow.RestoreBounds;
                union = Rect.Union(union, windowRect);
            }
            return union;
        }*/

        public static Dock WidgetToDock(Widget widget)
        {
            ArrayList thumbnaillist = widget.GetThumbnailPanelItems();
            widget.ClearThumbnailPanel();
            ArrayList iconlist = widget.GetIconPanelItems();
            widget.ClearIconPanel();
            Dock dock = new Dock();

            foreach (MediaItem item in thumbnaillist)
            {
                dock.AddToThumbnailPanel(item);
            }
            foreach (MediaItem item in iconlist)
            {
                dock.AddToIconPanel(item);
            }
            foreach (ItemWindow window in widget.windowList)
            {
                window.myOwner = dock;
            }
            dock.locale = widget.locale;
            dock.locale.dock = dock;
            dock.locale.widget = null;
            return dock;
        }

        public static Widget DockToWidget(Dock dock)
        {
            if (dock.orientation == Dock.DockOrientation.Right)
            {
                TransformDockFromRight(dock);
            }
            ArrayList thumbnaillist = dock.GetThumbnailPanelItems();
            dock.ClearThumbnailPanel();
            ArrayList iconlist = dock.GetIconPanelItems();
            dock.ClearIconPanel();
            Widget widget = new Widget();

            foreach (MediaItem item in thumbnaillist)
            {
                widget.AddToThumbnailPanel(item);
            }
            foreach (MediaItem item in iconlist)
            {
                widget.AddToIconPanel(item);
            }
            foreach (ItemWindow window in dock.windowList)
            {
                window.myOwner = widget;
            }
            widget.locale = dock.locale;
            widget.locale.widget = widget;
            widget.locale.dock = null;
            return widget;
        }

        public static double GetPreviewDockLength(Widget widget)
        {
            double length = 0;
            int wrapWidth = (int)Math.Ceiling(Math.Sqrt((double)widget.iconPanel.Children.Count));
            length += (16 + 4) * wrapWidth;
            length = 30 + length + 30;
            int stackCount = widget.thumbnailPanel.Children.Count + widget.canvas.Children.Count;
            length += (64 + 4) * stackCount;
            length = 30 + length + 30;
            return length;
        }

        public static void TransformDockToRight(Dock dock)
        {
            //TransformGroup transformGroup = new TransformGroup();
            //RotateTransform rotateTransform = new RotateTransform(90);
            //transformGroup.Children.Add(rotateTransform);

            //dock.dock.LayoutTransform = transformGroup;
            foreach (MediaItem item in dock.iconPanel.Children)
            {
                TransformMediaItemToRight(item);
            }

            foreach (MediaItem item in dock.thumbnailPanel.Children)
            {
                TransformMediaItemToRight(item);
            }
        }

        public static void TransformDockFromRight(Dock dock)
        {
            foreach (MediaItem item in dock.iconPanel.Children)
            {
                TransformMediaItemFromRight(item);
            }

            foreach (MediaItem item in dock.thumbnailPanel.Children)
            {
                TransformMediaItemFromRight(item);
            }
        }

        public static void TransformMediaItemToRight(MediaItem item)
        {
            TransformGroup tg = new TransformGroup();
            RotateTransform rt = new RotateTransform(-90);
            tg.Children.Add(rt);
            item.LayoutTransform = tg;
        }

        public static void TransformMediaItemFromRight(MediaItem item)
        {
            item.LayoutTransform = null;
        }

        public static void TransformDockToLeft(Dock dock)
        {
            TransformGroup transformGroup = new TransformGroup();
            RotateTransform rotateTransform = new RotateTransform(90);
            MatrixTransform matrixTransform = new MatrixTransform(-1, 0, 0, 1, 0, 0);
            transformGroup.Children.Add(rotateTransform);
            transformGroup.Children.Add(matrixTransform);

            dock.dock.LayoutTransform = transformGroup;
            foreach (MediaItem item in dock.iconPanel.Children)
            {
                TransformMediaItemToLeft(item);
            }

            foreach (MediaItem item in dock.thumbnailPanel.Children)
            {
                TransformMediaItemToLeft(item);
            }
        }

        public static void TransformMediaItemToLeft(MediaItem item)
        {
            TransformGroup tg = new TransformGroup();
            MatrixTransform mt = new MatrixTransform(-1, 0, 0, 1, 0, 0);
            RotateTransform rt = new RotateTransform(-90);
            tg.Children.Add(mt);
            tg.Children.Add(rt);
            item.LayoutTransform = tg;
        }

        public static void TransformMediaItemFromLeft(MediaItem item)
        {
            item.LayoutTransform = null;
        }

        public static void SortWindows(ArrayList windowList, double left, double top)
        {
            for (int i = 0; i < windowList.Count; i++)
            {
                //Storyboard sb = new Storyboard();
                ItemWindow window = windowList[i] as ItemWindow;
                //window.Name = "window" + i;
                DoubleAnimation widthAnimation = new DoubleAnimation();
                widthAnimation.To = 68;
                widthAnimation.Duration = TimeSpan.FromSeconds(0.5);
                //Storyboard.SetTargetName(widthAnimation, window.Name);
                //Storyboard.SetTargetProperty(widthAnimation, new PropertyPath(Window.WidthProperty));

                DoubleAnimation heightAnimation = new DoubleAnimation();
                heightAnimation.To = 68;
                heightAnimation.Duration = TimeSpan.FromSeconds(0.5);
                //Storyboard.SetTargetName(heightAnimation, window.Name);
                //Storyboard.SetTargetProperty(heightAnimation, new PropertyPath(Window.HeightProperty));

                DoubleAnimation leftAnimation = new DoubleAnimation();
                leftAnimation.To = left + 2 + 68 * i;
                leftAnimation.Duration = TimeSpan.FromSeconds(0.5);
                //Storyboard.SetTargetName(leftAnimation, window.Name);
                //Storyboard.SetTargetProperty(leftAnimation, new PropertyPath(Window.LeftProperty));

                DoubleAnimation rightAnimation = new DoubleAnimation();
                rightAnimation.To = top + 16;
                rightAnimation.Duration = TimeSpan.FromSeconds(0.5);
                //Storyboard.SetTargetName(rightAnimation, window.Name);
                //Storyboard.SetTargetProperty(rightAnimation, new PropertyPath(Window.TopProperty));

                window.BeginAnimation(Window.WidthProperty, widthAnimation);
                window.BeginAnimation(Window.HeightProperty, heightAnimation);
                window.BeginAnimation(Window.LeftProperty, leftAnimation);
                window.BeginAnimation(Window.TopProperty, rightAnimation);
                //sb.Children.Add(widthAnimation);
                //sb.Children.Add(heightAnimation);
                //sb.Children.Add(leftAnimation);
                //sb.Children.Add(rightAnimation);
                //sb.Begin();
                //window.Width = 68;
                //window.Height = 68;
                //window.Left = left + 2 + 68 * i;
                //window.Top = top + 16;
            }
            
        }

        public static void PrintSubscriptionEventArgs(SubscriptionEventArgs e)
        {
            Console.WriteLine("Reason " + e.Reason);
            Console.WriteLine("Sender " + e.Sender);
            Console.WriteLine("Path " + e.Path);
            Console.WriteLine("HasIndex " + e.HasIndex);
            if (e.HasIndex)
            {
                Console.WriteLine("Index " + e.Index);
            }
            Console.WriteLine("HasPreviousValue " + e.HasPreviousValue);
            if (e.HasPreviousValue)
            {
                Console.WriteLine("PreviousValue " + e.PreviousValue);
            }
            Console.WriteLine("Value " + e.Value);
            Console.WriteLine("Entry " + e.Entry);
        }
    }
}
