﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Collections;
using System.Threading;
using System.Windows.Media.Animation;
using MediaItemContract;

namespace UIDemo
{
    /// <summary>
    /// Interaction logic for ItemWindow.xaml
    /// </summary>
    public partial class ItemWindow : Window
    {
        public double dx;
        public double dy;

        private bool isDragging;
        public MediaItem mediaItem;
        private bool isOverlapping;

        public FrameworkElement myOwner;
        public FrameworkElement prospectOwner;

        private ArrayList itemWindowList;

        public ItemWindow()
        {
            InitializeComponent();
            isDragging = false;
            isOverlapping = false;
            //this.Opacity = 0.9;
            this.title.Visibility = Visibility.Collapsed;
        }


        private void Window_MouseUp(object sender, MouseButtonEventArgs e)
        {
            System.Console.WriteLine(e.ToString());
        }

        public void SetItem(MediaItem item)
        {
            //this.viewBox.Child = item;
            if (item != null)
            {
                //item.VerticalAlignment = VerticalAlignment.Stretch;
                //item.HorizontalAlignment = HorizontalAlignment.Stretch;
                container.Children.Add(item);
            }
            else
            {
                container.Children.Clear();
            }
            mediaItem = item;
        }

        private void Window_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            Point mPoint = this.PointToScreen(e.GetPosition(this));
            Point point = this.PointToScreen(new Point(0, 0));
            dx = mPoint.X - point.X;
            dy = mPoint.Y - point.Y;
            //Console.WriteLine("we are not supposed to be here 1");
            StartDragging(mPoint);
            //this.DragMove();
        }

        public void StartDragging(Point mPoint)
        {
            //Point point = this.PointToScreen(new Point(0, 0));
            //dx = mPoint.X - point.X;
            //dy = mPoint.Y - point.Y;
            //dx = x;
            //dy = y;

            Mouse.Capture(this, CaptureMode.SubTree);
            //Console.WriteLine("Mouse captured by item window");
            isDragging = true;
            this.title.Visibility = Visibility.Visible;
            //System.Console.WriteLine("hello i know");
        }

        private void Window_MouseMove(object sender, MouseEventArgs e)
        {
            if (isDragging)
            {
                Point mPoint = this.PointToScreen(e.GetPosition(this));
                this.Left = mPoint.X - dx;
                this.Top = mPoint.Y - dy;
                //mediaItem.MovingInOverlay();
                //System.Console.WriteLine("after");
                if (isInOwner(mPoint))
                {
                    if (myOwner is SystemWindow)
                    {
                        //Console.WriteLine("in 1");
                        /*SystemWindow window = myOwner as SystemWindow;
                        isDragging = false;
                        Mouse.Capture(null);
                        window.DragIn(mPoint, this);*/
                        if (prospectOwner != null)
                        {
                            //Console.WriteLine("in 2");
                            if (prospectOwner is Widget)
                            {
                                Widget widget = prospectOwner as Widget;
                                isDragging = false;
                                Mouse.Capture(null);
                                //Console.WriteLine("Mouse released by item window");
                                this.title.Visibility = Visibility.Collapsed;
                                widget.DragIn(mPoint, this);
                            }
                            else if (prospectOwner is Dock)
                            {
                                Dock dock = prospectOwner as Dock;
                                isDragging = false;
                                Mouse.Capture(null);
                                this.title.Visibility = Visibility.Collapsed;
                                //Console.WriteLine("Mouse released by item window");
                                dock.DragIn(mPoint, this);
                            }
                        }
                        else
                        {
                            //Console.WriteLine("in 3");
                            SystemWindow window = myOwner as SystemWindow;
                            isDragging = false;
                            Mouse.Capture(null);
                            this.title.Visibility = Visibility.Collapsed;
                            window.DragIn(mPoint, this);
                        }
                    }
                    else if (myOwner is Widget)
                    {
                        Widget widget = myOwner as Widget;
                        isDragging = false;
                        Mouse.Capture(null);
                        this.title.Visibility = Visibility.Collapsed;
                        widget.DragIn(mPoint, this);
                    }
                    else if (myOwner is Dock)
                    {
                        Dock dock = myOwner as Dock;
                        isDragging = false;
                        Mouse.Capture(null);
                        this.title.Visibility = Visibility.Collapsed;
                        dock.DragIn(mPoint, this);
                    }
                    //System.Console.WriteLine("no no");
                    /*if (this.Owner.GetType().Equals(typeof(Widget)))
                    {
                        Widget widget = this.Owner as Widget;
                        isDragging = false;
                        Mouse.Capture(null);
                        widget.DragIn(mPoint);
                    }
                    else if (this.Owner.GetType().Equals(typeof(SystemWindow)))
                    {
                        SystemWindow window = this.Owner as SystemWindow;
                        isDragging = false;
                        Mouse.Capture(null);
                        window.DragIn(mPoint, this);
                    }
                    else if (this.Owner.GetType().Equals(typeof(LocaleThumb)))
                    {
                        LocaleThumb widget = this.Owner as LocaleThumb;
                        isDragging = false;
                        Mouse.Capture(null);
                        widget.DragIn(mPoint);
                    }
                    else
                    {
                        Dock widget = this.Owner as Dock;
                        isDragging = false;
                        Mouse.Capture(null);
                        widget.DragIn(mPoint);
                    }*/

                }
                else
                {
                    if (myOwner is SystemWindow)
                    {
                        OverlappingTest();
                    }
                    //Console.WriteLine("overlapped");
                    //Rect union = GlobalVariables.GetUnionRect(
                }
            }
            //System.Console.WriteLine("please");
        }

        private bool isInOwner(Point mPoint)
        {
            if (myOwner is SystemWindow)
            {
                Locale locale = Account.singleton.FindDropTargetLocale(mPoint); //Locales.singleton.FindDropTargetLocale(mPoint);
                if (locale != null)
                {
                    /*if (mediaItem.mediaItem is IPersonItem)
                    {
                        //IPersonItem presenceItem = mediaItem.mediaItem as IPersonItem;
                        if (locale.HasMember(presenceItem.person))
                        {
                            return false;
                        }

                    }
                    else if (mediaItem.mediaItem is WebItem)
                    {
                        WebItem webItem = mediaItem.mediaItem as WebItem;
                        if (locale.HasMember(webItem.webPage))
                        {
                            return false;
                        }
                    }*/
                    if (locale.HasMember(mediaItem.member))
                    {
                        return false;
                    }
                    if (locale.widget != null)
                    {
                        Widget widget = locale.widget;
                        //myOwner = widget;
                        prospectOwner = widget;
                    }
                    else if (locale.dock != null)
                    {
                        Dock dock = locale.dock;
                        prospectOwner = dock;
                    }
                    return true;
                }
                else
                {
                    prospectOwner = null;
                    SystemWindow window = myOwner as SystemWindow;
                    if (!window.isOutOfBound(mPoint))
                    {
                        return true;
                    }
                }
                return false;
                //SystemWindow window = myOwner as SystemWindow;
                //if (!window.isOutOfBound(mPoint))
                //{
                //    return true;
                //}
                //return false;
            }
            else if (myOwner is Widget)
            {
                Widget widget = myOwner as Widget;
                if (!widget.isOutOfBound(mPoint))
                {
                    return true;
                }
                return false;
            }
            else if (myOwner is Dock)
            {
                Dock dock = myOwner as Dock;
                if (!dock.isOutOfBound(mPoint))
                {
                    return true;
                }
                return false;
            }
            return false;
            /*if (this.Owner.GetType().Equals(typeof(Widget)))
            {
                Widget widget = this.Owner as Widget;
                if (!widget.isOutOfBound(mPoint))
                {
                    return true;
                }
                return false;
            }
            else if (this.Owner.GetType().Equals(typeof(SystemWindow)))
            {
                SystemWindow window = this.Owner as SystemWindow;
                if (!window.isOutOfBound(mPoint))
                {
                    return true;
                }
                return false;
            }
            else if (this.Owner.GetType().Equals(typeof(LocaleThumb)))
            {
                LocaleThumb widget = this.Owner as LocaleThumb;
                if (!widget.isOutOfBound(mPoint))
                {
                    return true;
                }
                return false;
            }
            else
            {
                Dock widget = this.Owner as Dock;
                if (!widget.isOutOfBound(mPoint))
                {
                    return true;
                }
                return false;
            }*/
        }

        /*private void OverlappingTest()
        {
            ArrayList overlappedList = GlobalVariables.GetOverlappedWindows(this);
            if (overlappedList.Count > 0)
            {
                Rect union = GlobalVariables.GetUnionRect(overlappedList, this);
                GlobalVariables.borderWindow.Left = union.X;
                GlobalVariables.borderWindow.Top = union.Y;
                GlobalVariables.borderWindow.Width = union.Width;
                GlobalVariables.borderWindow.Height = union.Height;
                if (!GlobalVariables.borderWindow.IsVisible)
                {
                    GlobalVariables.borderWindow.Show();
                }
                isOverlapping = true;
            }
            else
            {
                if (GlobalVariables.borderWindow.IsVisible)
                {
                    GlobalVariables.borderWindow.Hide();
                }
                isOverlapping = false;
            }
        }*/

        private void OverlappingTest()
        {
            ArrayList overlappedList = Account.singleton.GetOverlappedWindows(this);
            if (overlappedList.Count > 0)
            {
                Rect union = Account.singleton.GetUnionRect(overlappedList, this);
                Account.singleton.borderWindow.Left = union.X;
                Account.singleton.borderWindow.Top = union.Y;
                Account.singleton.borderWindow.Width = union.Width;
                Account.singleton.borderWindow.Height = union.Height;
                if (!Account.singleton.borderWindow.IsVisible)
                {
                    Account.singleton.borderWindow.Show();
                }
                isOverlapping = true;
            }
            else
            {
                if (Account.singleton.borderWindow.IsVisible)
                {
                    Account.singleton.borderWindow.Hide();
                }
                isOverlapping = false;
            }
        }

        private void Window_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            isDragging = false;
            Mouse.Capture(null);
            //System.Console.WriteLine("up");
            if (myOwner is SystemWindow && isOverlapping)
            {
                ArrayList overlappedList = Account.singleton.GetOverlappedWindows(this);
                overlappedList.Add(this);
                overlappedList.Sort(new WindowComparer());
                Account.singleton.SortWindows(overlappedList, Account.singleton.borderWindow.Left, Account.singleton.borderWindow.Top);
                itemWindowList = overlappedList;
                DoubleAnimation nullAnimation = new DoubleAnimation();
                nullAnimation.Duration = TimeSpan.FromSeconds(0.5);
                nullAnimation.Completed += new EventHandler(nullAnimation_Completed);
                this.BeginAnimation(Window.OpacityProperty, nullAnimation);
                //Widget widget = GlobalVariables.CreateLocaleWidget(overlappedList);
                //widget.Left = GlobalVariables.borderWindow.Left;
                //widget.Top = GlobalVariables.borderWindow.Top;
                //widget.Width = 300;
                //widget.Height = 400;
                //widget.Show();
                //isOverlapping = false;
                //if (GlobalVariables.borderWindow.IsVisible)
                //{
                //    GlobalVariables.borderWindow.Hide();
                //}
            }
        }

        void nullAnimation_Completed(object sender, EventArgs e)
        {
            Widget widget = Account.singleton.CreateLocaleWidget(itemWindowList);
            widget.Left = Account.singleton.borderWindow.Left;
            widget.Top = Account.singleton.borderWindow.Top;
            //widget.Width = 300;
            //widget.Height = 400;
            //widget.SetThumbnail();
            widget.InitialSize();
            widget.Show();
            //Console.WriteLine(widget.iconPanel.ActualWidth);
            isOverlapping = false;
            if (Account.singleton.borderWindow.IsVisible)
            {
                Account.singleton.borderWindow.Hide();
            }
        }

        public void SetOpacity(double opacity)
        {
            this.Opacity = opacity;
        }

        public void SetGrip()
        {
            this.ResizeMode = ResizeMode.CanResizeWithGrip;
        }

        public void RemoveGrip()
        {
            this.ResizeMode = ResizeMode.NoResize;
        }

        private void Window_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            if (mediaItem == null)
            {
                return;
            }
            //Console.WriteLine(mediaItem.ActualHeight + " " + mediaItem.ActualWidth);
            if (e.WidthChanged)
            {
                //mediaItem.Width = this.Width - mediaItem.Margin.Left - mediaItem.Margin.Right;
                mediaItem.Width = this.container.ActualWidth - mediaItem.Margin.Left - mediaItem.Margin.Right;
            }
            if (e.HeightChanged)
            {
                //mediaItem.Height = this.Height - mediaItem.Margin.Top - mediaItem.Margin.Bottom;
                mediaItem.Height = this.container.ActualHeight - mediaItem.Margin.Top - mediaItem.Margin.Bottom;
            }
            //Console.WriteLine("window  " + mediaItem.Width + " " + mediaItem.Height);
            //Console.WriteLine("item  " + mediaItem.Width + " " + mediaItem.Height);
        }
    }
}
