﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MediaItemContract;

namespace UIDemo
{
    /// <summary>
    /// Interaction logic for LocaleThumbnailItem.xaml
    /// </summary>
    public partial class LocaleThumbnailItem : UserControl, LocaleContainer, ICloneable
    {
        //public Locale locale;
        public LocaleThumbnailItem(Locale locale)
        {
            InitializeComponent();
            this.locale = locale;
        }

        public void AddToIconPanel(MediaItem item)
        {
            item.Width = 16;
            item.Height = 16;
            item.Margin = new Thickness(2);
            item.VerticalAlignment = VerticalAlignment.Top;
            //item.MouseLeftButtonDown += new MouseButtonEventHandler(IconItem_MouseLeftButtonDown);
            //item.MouseMove += new MouseEventHandler(IconItem_MouseMove);
            //item.MouseLeave += new MouseEventHandler(IconItem_MouseLeave);
            //item.MouseWheel += new MouseWheelEventHandler(IconItem_MouseWheel);
            //item.MouseRightButtonDown += new MouseButtonEventHandler(IconItem_MouseRightButtonDown);
            iconPanel.Children.Add(item);
        }

        public void RemoveFromIconPanel(LocaleMember member)
        {
            MediaItem itemToRemove = null;
            foreach (MediaItem item in iconPanel.Children)
            {
                if (item.member == member)
                {
                    itemToRemove = item;
                    break;
                }
            }
            iconPanel.Children.Remove(itemToRemove);
        }

        public Widget CreateWidget()
        {
            Widget widget = new Widget();
            locale.widget = widget;
            widget.locale = locale;
            foreach (MediaItem item in iconPanel.Children)
            {
                /*MediaItem newItem = new MediaItem();
                if (item.mediaItem is IPersonItem)
                {
                    IPersonItem personItem = 
                    newItem.SetMediaItem((IItem)((IItem)item.GetMediaItem()).Clone());
                }
                else
                {

                }*/
                //widget.AddToThumbnailPanel(newItem);
                MediaItem newItem = item.Clone() as MediaItem;
                newItem.levelState = MediaItem.LevelState.Thumbnail;
                widget.AddToThumbnailPanel(newItem);
                /*if (item.mediaItem is PresenceItem)
                {
                    PresenceItem presenceItem = item.mediaItem as PresenceItem;
                    //locale.AddItem(presenceItem.person);
                    //if (presenceItem.person.guid != Locales.singleton.myGuid)
                    //{
                    //    presenceItem.person.AddLocale(locale);
                    //}
                }
                else if (item.mediaItem is WebItem)
                {
                    WebItem webItem = item.mediaItem as WebItem;
                    //locale.AddItem(webItem.webPage);
                }*/
            }
            widget.InitialSize();
            widget.ShrinkToIcon();
            return widget;
        }



        #region LocaleContainer Members

        public Locale locale { get; set; }

        #endregion

        #region ICloneable Members

        public object Clone()
        {
            return new LocaleThumbnailItem(this.locale);
        }

        #endregion
    }
}
