﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace UIDemo
{
    /// <summary>
    /// Interaction logic for LocaleWindow.xaml
    /// </summary>
    public partial class LocaleWindow : Window
    {
        public double dx;
        public double dy;

        private bool isDragging;

        //public LocaleThumbnailItem item;
        public FrameworkElement item;

        public LocaleWindow()
        {
            InitializeComponent();
        }

        public LocaleWindow(FrameworkElement item)
        {
            InitializeComponent();
            this.item = item;
            //this.container.Children.Add(item);
            this.DataContext = this.item;
        }

        private void Window_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            Point mPoint = this.PointToScreen(e.GetPosition(this));
            Point point = this.PointToScreen(new Point(0, 0));
            dx = mPoint.X - point.X;
            dy = mPoint.Y - point.Y;
            isDragging = true;
            //Mouse.Capture(this, CaptureMode.SubTree);
            Mouse.Capture(this);
        }

        private void Window_MouseMove(object sender, MouseEventArgs e)
        {
            if (isDragging)
            {
                Point mPoint = this.PointToScreen(e.GetPosition(this));
                this.Left = mPoint.X - dx;
                this.Top = mPoint.Y - dy;
            }
        }

        private void Window_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            isDragging = false;
            Mouse.Capture(null);
        }


    }
}
