﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GroupLab.Networking;
using System.Collections;
using System.Windows.Threading;

namespace UIDemo
{
    public class Locales
    {
        public static Locales singleton;

        SharedDictionary sd;
        SystemWindow sw;
        public string myGuid;
        Subscription localeSub;
        public static string localesPath = "/locales/";
        public string myLocalesPath;
        Hashtable localeList;

        public delegate void AddLocaleDelegate();

        public Locales(SharedDictionary sd, SystemWindow sw, string guid)
        {
            this.sd = sd;
            this.sw = sw;
            this.myGuid = guid;
            //myLocalesPath = People.peoplePath + guid + "/locales";
            myLocalesPath = People.peoplePath + guid + "/locales/";
            //GroupLab.Networking.SharedDictionary.Vector myLocales = new SharedDictionary.Vector();
            //this.sd[myLocalesPath] = myLocales;
            localeList = new Hashtable();
            this.localeSub = new Subscription();
            this.localeSub.BeginInit();
            this.localeSub.Dictionary = this.sd;
            //this.localeSub.Pattern = myLocalesPath;
            this.localeSub.Pattern = myLocalesPath +"?";
            this.localeSub.Notified += new SubscriptionEventHandler(localeSub_Notified);
            this.localeSub.EndInit();
        }

        void localeSub_Notified(object sender, SubscriptionEventArgs e)
        {
            if (e.Reason == SubscriptionNotification.Add)
            {
                //Console.WriteLine("LocaleVector added");
                //Console.WriteLine("Added Index " + e.Index);
                //Console.WriteLine("Added Value " + e.Value);
                //Console.WriteLine("Added Attribute " + e.AttributeName);
                //Console.WriteLine("Added Path " + e.Path);
                /*if (e.HasIndex)
                {
                    string guid = e.Value as string;
                    AddLocaleDelegate newLocaleDelegate = delegate
                    {
                        AddUILocale(guid);
                    };
                    this.sw.Dispatcher.BeginInvoke(newLocaleDelegate, DispatcherPriority.Background);
                }
                else
                {
                    GroupLab.Networking.SharedDictionary.Vector myLocales = e.Value as GroupLab.Networking.SharedDictionary.Vector;
                    foreach (string guid in myLocales)
                    {
                        string localeGuid = guid;
                        AddLocaleDelegate newLocaleDelegate = delegate
                        {
                            AddUILocale(localeGuid);
                        };
                        this.sw.Dispatcher.BeginInvoke(newLocaleDelegate, DispatcherPriority.Background);
                    }
                }*/
                string guid = e.Value as string;
                AddLocaleDelegate newLocaleDelegate = delegate
                {
                    AddUILocale(guid);
                };
                this.sw.Dispatcher.BeginInvoke(newLocaleDelegate, DispatcherPriority.Background);
            }
            else if (e.Reason == SubscriptionNotification.Remove)
            {
                string guid = e.PreviousValue as string;
                AddLocaleDelegate removeLocaleDelegate = delegate
                {
                    RemoveUILocale(guid);
                };
                this.sw.Dispatcher.BeginInvoke(removeLocaleDelegate, DispatcherPriority.Background);
                /*if (e.HasIndex)
                {
                    string guid = e.PreviousValue as string;
                    AddLocaleDelegate removeLocaleDelegate = delegate
                    {
                        RemoveUILocale(guid);
                    };
                    this.sw.Dispatcher.BeginInvoke(removeLocaleDelegate, DispatcherPriority.Background);
                }
                else
                {
                    
                }*/
            }
            /*if (e.Reason == SubscriptionNotification.Change)
            {
                Console.WriteLine("LocaleVector changed");
            }
            if (e.Reason == SubscriptionNotification.AttributeChange)
            {
                Console.WriteLine("LocaleVector's attributes changed");
            }*/
        }

        public void AddUILocale(string guid)
        {
            Locale locale = localeList[guid] as Locale;
            if (locale == null)
            {
                locale = new Locale(guid);
                localeList[guid] = locale;
                AddLocaleContainer(locale);
            }
            //Locale locale = new Locale(guid);
            //localeList.Add(locale);
            //LocaleThumbnailItem localeThumbnail = new LocaleThumbnailItem(locale);
            //sw.AddLocaleThumbnail(localeThumbnail);
            //locale.Initialize(localeThumbnail);
        }

        public void AddLocaleContainer(Locale locale)
        {
            //LocaleThumbnailItem localeThumbnail = new LocaleThumbnailItem(locale);
            //sw.AddLocaleThumbnail(localeThumbnail);
            LocaleTileItem localeTile = new LocaleTileItem(locale);
            sw.AddLocaleTile(localeTile);
            //locale.tile = localeTile;
            locale.Initialize(null, localeTile, this.sw.Dispatcher);
        }

        public void RemoveLocaleContainer(Locale locale)
        {
            sw.RemoveLocaleThumbnail(locale);
            if (locale.widget != null)
            {
                locale.widget.Close();
            }
            if (locale.dock != null)
            {
                locale.dock.dockContainer.dockStation.Remove(locale.dock.dockContainer);
            }
        }

        public string AddLocale(Locale locale)
        {
            Map item = new Map();
            //string guid = System.Guid.NewGuid().ToString();
            string guid = locale.guid;
            item["guid"] = guid;
            localeList[guid] = locale;
            this.sd[localesPath + guid] = item;
            locale.AddMySelf();
            //this.sd[myLocalesPath + "#-0"] = guid;
            this.sd[myLocalesPath + guid] = guid;
            AddLocaleContainer(locale);
            //locale.guid = guid;
            //locale.Initialize();
            //localeList.Add(locale);
            return guid;
        }

        public Locale CreateLocale()
        {
            string guid = System.Guid.NewGuid().ToString();
            Locale locale = new Locale(guid);
            AddLocale(locale);
            /*Map item = new Map();
            item["guid"] = guid;
            this.sd[localesPath + guid] = item;
            this.sd[myLocalesPath + "#-0"] = guid;
            locale.guid = guid;
            locale.Initialize();
            localeList.Add(locale);*/
            return locale;
        }

        public void RemoveLocale(Locale locale)
        {
            if (localeList.ContainsKey(locale.guid))
            {
                localeList.Remove(locale.guid);
                locale.RemoveDataPerson(myGuid);
                if (locale.IsLocaleEmpty())
                {
                    this.sd.Remove(localesPath + locale.guid+"*");
                }
                RemoveLocaleContainer(locale);
                //GroupLab.Networking.SharedDictionary.Vector v1 = this.sd[myLocalesPath] as GroupLab.Networking.SharedDictionary.Vector;
                //int index = v1.IndexOf(locale.guid, 0);
                //this.sd.Remove(myLocalesPath + "#+" + index);
                this.sd.Remove(myLocalesPath + locale.guid);
            }
        }

        public void RemoveUILocale(string guid)
        {
            Locale locale = localeList[guid] as Locale;
            if (locale != null)
            {
                localeList.Remove(locale.guid);
                RemoveLocaleContainer(locale);
                //RemoveLocale(locale);
            }
        }

        public Locale FindDropTargetLocale(System.Windows.Point point)
        {
            foreach (Locale locale in localeList.Values)
            {
                if (locale.widget != null)
                {
                    if (!locale.widget.isOutOfBound(point))
                    {
                        return locale;
                    }
                }
                else if (locale.dock != null)
                {
                    if (!locale.dock.isOutOfBound(point))
                    {
                        return locale;
                    }
                }
            }
            return null;
        }
    }
}
