﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MediaItemContract;

namespace UIDemo
{
    /// <summary>
    /// Interaction logic for MediaItem.xaml
    /// </summary>
    public partial class MediaItem : UserControl, ICloneable
    {
        public IItem mediaItem;
        public LocaleMember member;

        public enum LevelState
        {
            Icon,
            Thumbnail,
            Interaction
        }

        public LevelState levelState { get; set; }

        private UserControl icon;
        private UserControl thumbnail;
        public UserControl interactive;

        public bool isInWindow;
        public bool isPinned;

        public MediaItem()
        {
            InitializeComponent();
        }

        /*public MediaItem(IItem item, LocaleMember member)
        {
            InitializeComponent();
            SetMediaItem(item, member);
        }*/

        public MediaItem(LocaleMember localeMember)
        {
            InitializeComponent();
            //SetMediaItem(item, member);
            this.LocaleMember = localeMember;
        }

        /*public void SetMediaItem(IItem item, LocaleMember member)
        {
            mediaItem = item;
            this.member = member;
            icon = item.GetIconItem();
            thumbnail = item.GetThumbnailItem();
            interactive = item.GetInteractionItem();
            //this.Content = interactive;
        }*/

        public IItem GetMediaItem()
        {
            return mediaItem;
        }

        public void Clear()
        {
            this.Content = null;
            //viewBox.Child = null;
        }

        private void UserControl_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            //System.Console.WriteLine(this.ActualHeight + " " + this.ActualWidth);
            UpdateSize();
        }

        public void UpdateSize()
        {
            //System.Console.WriteLine(this.ActualHeight + " " + this.ActualWidth);
            if (this.ActualHeight < 64 || this.ActualWidth < 64)
            {
                this.Content = icon;
                //this.Content = mediaItem.GetIconItem();
                //this.levelState = LevelState.Icon;
            }
            else if (this.ActualHeight < 256 || this.ActualWidth < 256)
            {
                this.Content = thumbnail;
                //this.Content = mediaItem.GetThumbnailItem();
                //this.levelState = LevelState.Thumbnail;
            }
            else
            {
                this.Content = interactive;
                //this.Content = mediaItem.GetThumbnailItem();
                //this.levelState = LevelState.Interaction;
            }
        }


        /*public void ToBeDetachedFromContainer()
        {
            mediaItem.ToBeDetachedFromContainer();
        }

        public void ToBeAttachedToOverlay()
        {
            mediaItem.ToBeAttachedToOverlay();
        }

        public void AttachedToOverlay()
        {
            mediaItem.AttachedToOverlay();
        }

        public void TeBeDetachedFromOverlay()
        {
            mediaItem.TeBeDetachedFromOverlay();
        }

        public void ToBeAttachedToContainer()
        {
            mediaItem.ToBeAttachedToContainer();
        }

        public void AttachedToContainer()
        {
            mediaItem.AttachedToContainer();
        }

        public void MovingInOverlay()
        {
            mediaItem.MovingInOverlay();
        }*/

        public LocaleMember LocaleMember
        {
            get { return (LocaleMember)GetValue(LocaleMemberProperty); }
            set { SetValue(LocaleMemberProperty, value); }
        }

        public static readonly DependencyProperty LocaleMemberProperty =
            DependencyProperty.Register("LocaleMember", typeof(LocaleMember), typeof(MediaItem), new UIPropertyMetadata(null, new PropertyChangedCallback(OnLocaleMemberChanged)));

        private static void OnLocaleMemberChanged(DependencyObject sender, DependencyPropertyChangedEventArgs e)
        {
            MediaItem mediaItem = sender as MediaItem;
            if (e.NewValue == null)
            {
                mediaItem.icon = null;
                mediaItem.thumbnail = null;
                mediaItem.interactive = null;
                mediaItem.mediaItem = null;
                mediaItem.member = null;
            }
            else
            {
                LocaleMember newMember = e.NewValue as LocaleMember;
                //mediaItem.SetMediaItem(newMember.createPluginItem(), newMember);
                IItem item = newMember.createPluginItem();
                mediaItem.mediaItem = item;
                mediaItem.member = newMember;
                mediaItem.icon = item.GetIconItem();
                mediaItem.thumbnail = item.GetThumbnailItem();
                mediaItem.interactive = item.GetInteractionItem();
            }

        }

        #region ICloneable Members

        //need care
        public object Clone()
        {
            //MediaItem item = new MediaItem();
            /*if (this.mediaItem is IPersonItem)
            {
                IPersonItem personItem = this.mediaItem.Clone() as IPersonItem;
                item.SetMediaItem(personItem, this.member);
            }
            else
            {
                IArtifactItem artifactItem = this.mediaItem
                //item.SetMediaItem(this.mediaItem.Clone() as IItem);
            }*/
            //item.SetMediaItem(this.mediaItem.Clone() as IItem, this.member);
            MediaItem item = new MediaItem(this.LocaleMember);
            return item;
        }

        #endregion

        private void UserControl_Drop(object sender, DragEventArgs e)
        {
            DropDataObject(e.Data);
        }

        public void DropDataObject(IDataObject data)
        {
            if (mediaItem is IArtifactItem)
            {
                ((IArtifactItem)mediaItem).DropData(data);
            }
        }
    }
}
