﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GroupLab.Networking;
using System.Windows.Threading;
using System.Collections;
using System.Collections.ObjectModel;

namespace UIDemo
{
    public class People
    {
        SharedDictionary sd;
        SystemWindow sw;
        string guid;
        Subscription peopleSub;
        Subscription contactsSub;
        public static string peoplePath = "/people/";
        //ArrayList personList;
        public ObservableCollection<Person> contactList;
        public Hashtable contactHash;
        public ObservableCollection<Person> directory { get; set; }
        public Hashtable directoryHash;
        private object sdLock = "shared dictionary";

        public delegate void noParaDelegate();

        public People(SharedDictionary sd, SystemWindow sw, string guid)
        {
            this.sd = sd;
            this.sw = sw;
            this.guid = guid;
            //personList = new ArrayList();

            directory = new ObservableCollection<Person>();
            directoryHash = new Hashtable();

            contactList = new ObservableCollection<Person>();
            contactHash = new Hashtable();

            this.peopleSub = new Subscription();
            this.peopleSub.BeginInit();
            peopleSub.Dictionary = this.sd;
            peopleSub.Pattern = peoplePath + "?";
            peopleSub.Notified += new SubscriptionEventHandler(peopleSub_Notified);
            peopleSub.EndInit();

            
            this.contactsSub = new Subscription();
            this.contactsSub.BeginInit();
            contactsSub.Dictionary = this.sd;
            //contactsSub.Pattern = peoplePath + this.guid + "/contacts";
            contactsSub.Pattern = peoplePath + this.guid + "/contacts/?";
            contactsSub.Notified += new SubscriptionEventHandler(contactsSub_Notified);
            contactsSub.EndInit();
        }

        void contactsSub_Notified(object sender, SubscriptionEventArgs e)
        {
            //string guid = e.Value as string;
            Map map = e.Value as Map;
            string guid = map["guid"] as string;
            noParaDelegate addUIContact = delegate
            {
                AddUIContact(guid);
            };
            sw.Dispatcher.BeginInvoke(addUIContact, DispatcherPriority.Background);
            /*if (e.Reason == SubscriptionNotification.Add)
            {
                if (e.HasIndex)
                {
                    string guid = e.Value as string;
                    noParaDelegate addUIContact = delegate
                    {
                        AddUIContact(guid);
                    };
                    sw.Dispatcher.BeginInvoke(addUIContact, DispatcherPriority.Background);
                }
                else
                {
                    GroupLab.Networking.SharedDictionary.Vector contacts = e.Value as GroupLab.Networking.SharedDictionary.Vector;
                    foreach (string guid in contacts)
                    {
                        string contactGuid = guid;
                        noParaDelegate addUIContact = delegate
                        {
                            AddUIContact(contactGuid);
                        };
                        sw.Dispatcher.BeginInvoke(addUIContact, DispatcherPriority.Background);
                    }
                }
            }*/
        }

        void AddUIContact(string guid)
        {
            lock (sdLock)
            {
                Person contact = contactHash[guid] as Person;
                if (contact == null)
                {
                    if (directoryHash.ContainsKey(guid))
                    {
                        Person person = directoryHash[guid] as Person;
                        person.IsBuddy = true;
                        contactHash[guid] = person;
                        sw.AddPerson(person);
                    }
                    else
                    {
                        Person person = new Person(guid, Account.singleton.itemLoader.currentPersonPlugin);
                        person.IsBuddy = true; //or down there
                        contactHash[guid] = person;
                        sw.AddPerson(person);
                    }
                }
            }
        }

        public void AddContact(Person person)
        {
            lock (sdLock)
            {
                if (!this.contactHash.ContainsKey(person.guid))
                {
                    if (directoryHash.ContainsKey(person.guid))
                    {
                        Person contact = directoryHash[person.guid] as Person;
                        //person.IsBuddy = true;
                        contactHash[person.guid] = contact;
                        sw.AddPerson(person);
                    }
                    else
                    {
                        Person contact = new Person(person.guid, Account.singleton.itemLoader.currentPersonPlugin);
                        //person.IsBuddy = true; //or down there
                        contactHash[person.guid] = contact;
                        sw.AddPerson(person);
                    }
                    //contactHash[guid] = 
                    //this.sd[peoplePath + this.guid + "/contacts#-0"] = person.guid;
                    Map map = new Map();
                    map["guid"] = person.guid;
                    //this.sd[peoplePath + this.guid + "/contacts/" + person.guid] = person.guid;
                    this.sd[peoplePath + this.guid + "/contacts/" + person.guid] = map;
                    //Console.WriteLine("added contact " + guid);
                }
            }
        }

        public void RemoveContact(Person person)
        {
            lock (sdLock)
            {
                if (this.contactHash.ContainsKey(person.guid))
                {
                    this.contactHash.Remove(person.guid);
                    //GroupLab.Networking.SharedDictionary.Vector v1 = this.sd[peoplePath + this.guid + "/contacts"] as GroupLab.Networking.SharedDictionary.Vector;
                    //int index = v1.IndexOf(guid, 0);
                    //this.sd.Remove(peoplePath + this.guid + "/contacts#+" + index);
                    this.sd.Remove(peoplePath + this.guid + "/contacts/" + person.guid);
                    //Console.WriteLine("remove contact at " + index);
                    sw.RemovePerson(person);
                }
            }
        }

        void peopleSub_Notified(object sender, SubscriptionEventArgs e)
        {
            if (e.Reason == SubscriptionNotification.Add)
            {
                //string guid = this.sd[e.Path + "#guid"] as string;
                Map map = e.Value as Map;
                string guid = map["guid"] as string;
                //Console.WriteLine("the new path is " + e.Path + ".guid");
                Console.WriteLine("the new guid is " + guid);

                /*if (guid == Account.singleton.guid)
                {
                    return;
                }*/
                if (sw.CheckAccess())
                {
                    //sw.AddPerson(person);
                }
                else
                {
                    //Console.WriteLine("WTF");
                    noParaDelegate swAddPerson = delegate
                    {
                        //Person person = new Person(guid);
                        //this.personList.Add(person);
                        //this.directory.Add(person);
                        //this.directoryHash[guid] = person;
                        //Console.WriteLine("default thumbnail size " + sw.defaultThumbnailSize);
                        //sw.AddPerson(person);
                        AddUIPerson(guid);
                    };
                    sw.Dispatcher.BeginInvoke(swAddPerson, DispatcherPriority.Background);
                }
            }
        }

        void AddUIPerson(string guid)
        {
            lock (sdLock)
            {
                Person person = directoryHash[guid] as Person;
                if (person == null)
                {
                    if (contactHash.ContainsKey(guid))
                    {
                        Person contact = contactHash[guid] as Person;
                        //contact.IsBuddy = true;
                        directoryHash[guid] = contact;
                        this.directory.Add(contact);
                    }
                    else
                    {
                        Person contact = new Person(guid, Account.singleton.itemLoader.currentPersonPlugin);
                        /*if (guid == Account.singleton.guid)
                        {
                            contact.NotSelf = false;
                            //Console.WriteLine("Trying to add self");
                        }
                        else
                        {
                            contact.NotSelf = true;
                        }*/

                        directoryHash[guid] = contact;
                        this.directory.Add(contact);
                    }
                }
            }
        }

        /*public string CreateAccount()
        {
            Map account = new Map();
            string guid = System.Guid.NewGuid().ToString();
            account["guid"] = guid;
            //Account.singleton.guid = guid;
            this.sd[peoplePath + guid] = account;
            GroupLab.Networking.SharedDictionary.Vector artifacts = new SharedDictionary.Vector();
            this.sd[peoplePath + guid + "/artifacts"] = artifacts;
            //Map contacts = new Map();
            GroupLab.Networking.SharedDictionary.Vector contacts = new SharedDictionary.Vector();
            this.sd[peoplePath + guid + "/contacts"] = contacts;
            return guid;
        }*/
    }
}
