﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.IO;
using GroupLab.Networking;
using System.ComponentModel;
using System.Windows;
using MediaItemContract;

namespace UIDemo
{
    public class Person: LocaleMember
    {
        private bool isBuddy;
        private bool notSelf;
        Subscription personSub;
        //Map personMap;
        public Person(string guid, Plugin plugin)
            : base(guid, plugin)
        {
            //personMap = this.sd[People.peoplePath + this.guid] as Map;
            this.personSub = new Subscription();
            this.personSub.BeginInit();
            personSub.Dictionary = this.sd;
            personSub.Pattern = People.peoplePath + this.guid;
            personSub.Notified += new SubscriptionEventHandler(personSub_Notified);
            personSub.EndInit();
        }

        void personSub_Notified(object sender, SubscriptionEventArgs e)
        {
            if (e.Reason == SubscriptionNotification.Add)
            {
                if (e.HasIndex)
                {

                }
                else
                {

                }
            }
        }

        public void SetOnline()
        {
            this.sd[People.peoplePath + this.guid + "/connected"] = "hello";
            this.sd[People.peoplePath + this.guid + "/connected.transient"] = this.sd.Id;
        }

        public void UpdateImage(BitmapSource image)
        {
            MemoryStream stream = new MemoryStream();
            JpegBitmapEncoder encoder = new JpegBitmapEncoder();
            encoder.FlipVertical = true;
            encoder.QualityLevel = 60;
            encoder.Frames.Add(BitmapFrame.Create(image));
            encoder.Save(stream);
            //stream.Seek(0, SeekOrigin.Begin);
            //this.sd[People.peoplePath + this.guid + "/image"] = stream.ToArray();
            this.sd[People.peoplePath + this.guid + "/image"] = stream;
            //this.sd[People.peoplePath + this.guid + "/image.unreliable"] = "true";
            //stream.Dispose();
        }

        public void AddLocale(Locale locale)
        {
            //this.sd[People.peoplePath + this.guid + "/locales#-0"] = locale.guid;
            this.sd[People.peoplePath + this.guid + "/locales/" + locale.guid] = locale.guid;
        }

        public void QuitLocale(Locale locale)
        {
            //GroupLab.Networking.SharedDictionary.Vector v1 = this.sd[People.peoplePath + this.guid + "/locales"] as GroupLab.Networking.SharedDictionary.Vector;
            //int index = v1.IndexOf(locale.guid, 0);
            //this.sd.Remove(People.peoplePath + this.guid + "/locales#+" + index);
            this.sd.Remove(People.peoplePath + this.guid + "/locales/" + locale.guid);
        }

        public bool IsBuddy
        {
            get { return isBuddy; }
            set
            {
                isBuddy = value;
                if (isBuddy)
                {
                    Account.singleton.people.AddContact(this);
                }
                else
                {
                    Account.singleton.people.RemoveContact(this);
                }
                OnPropertyChanged("IsBuddy");
            }
        }

        public bool NotSelf
        {
            get
            {
                if (this.guid == Account.singleton.guid)
                {
                    return false;
                    //Console.WriteLine("Trying to add self");
                }
                else
                {
                    return true;
                }
                //return notSelf;
            }
            /*set
            {
                notSelf = value;
                OnPropertyChanged("NotSelf");
            }*/
        }

        public override MediaItem createMediaItem()
        {
            /*IPersonItem personItem = this.plugin.CreatePlugin() as IPersonItem;
            personItem.StartItem(this.sd, People.peoplePath + this.guid);
            MediaItem mediaItem = new MediaItem(personItem, this);
            mediaItem.Width = 64;
            mediaItem.Height = 64;*/
            MediaItem mediaItem = new MediaItem(this);
            return mediaItem;
        }

        public override IItem createPluginItem()
        {
            IPersonItem personItem = this.plugin.CreatePlugin() as IPersonItem;
            PersonContractHelper personHelper = new PersonContractHelper(this.sd, this.guid);
            personItem.StartItem(this.sd, People.peoplePath + this.guid, personHelper);
            return personItem;
        }
    }
}
