﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace UIDemo
{
    /// <summary>
    /// Interaction logic for PlaceHolder.xaml
    /// </summary>
    public partial class PlaceHolder : UserControl
    {
        public DockStation dockStation;
        public double gap;
        public PlaceHolder(DockStation dockStation)
        {
            InitializeComponent();
            gap = 20;
            this.dockStation = dockStation;
            this.VerticalAlignment = VerticalAlignment.Top;
        }

        public double ClearToLeft(double offset)
        {
            double possibleWidthOffset = this.Width - gap;
            if (possibleWidthOffset >= offset)
            {
                this.Width -= offset;
                return offset;
            }
            else
            {
                int index = dockStation.dock.Children.IndexOf(this);
                if (index > 1)
                {
                    DockContainer frontDock = dockStation.dock.Children[index - 1] as DockContainer;
                    double actualOffset = frontDock.ShiftToLeft(offset - possibleWidthOffset) + possibleWidthOffset;
                    this.Width = gap;
                    return actualOffset;
                }
                else
                {
                    double actualOffset = possibleWidthOffset;
                    this.Width = gap;
                    return actualOffset;
                }
            }
        }

        public double ClearToRight(double offset)
        {
            double possibleWidthOffset = this.Width - gap;
            if (possibleWidthOffset >= offset)
            {
                this.Width -= offset;
                return offset;
            }
            else
            {
                int index = dockStation.dock.Children.IndexOf(this);
                if (index < dockStation.dock.Children.Count - 2)
                {
                    DockContainer rearDock = dockStation.dock.Children[index + 1] as DockContainer;
                    double actualOffset = rearDock.ShiftToRight(offset - possibleWidthOffset) + possibleWidthOffset;
                    this.Width = gap;
                    return actualOffset;
                }
                else
                {
                    double actualOffset = possibleWidthOffset;
                    this.Width = gap;
                    return actualOffset;
                }
            }
        }
    }
}
