﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Collections;
using MediaItemContract;


namespace UIDemo
{
    /// <summary>
    /// Interaction logic for SystemWindow.xaml
    /// </summary>
    public partial class SystemWindow : Window
    {
        Account account;

        //private MediaItem placeHolder;
        //public ArrayList itemList;
        public ArrayList windowList;
        private MediaItem movingItem;
        private ItemWindow movingWindow;

        private double dx;
        private double dy;
        private bool isDragging;
        private Panel focusPanel;
        private int overIndex;
        private int hitIndex = -1;
        private Panel hitPanel = null;

        //private MediaItem resizingItem;
        private double currentIconSize;
        public double defaultThumbnailSize;
        private double defaultInWindowSize;
        private double defaultItemMargin;

        private InsertIndicator insertIndicator;

        //public DataStore ds;

        public SystemWindow()
        {
            InitializeComponent();
            this.peopleTab.Visibility = Visibility.Collapsed;
            this.artefactTab.Visibility = Visibility.Collapsed;
            this.localeTab.Visibility = Visibility.Collapsed;
            this.meTab.Visibility = Visibility.Collapsed;
            isDragging = false;
            currentIconSize = 16;
            defaultThumbnailSize = 64;
            defaultInWindowSize = 96;
            defaultItemMargin = 2;
            

            insertIndicator = new InsertIndicator();

            windowList = new ArrayList();

            


            
            //PopulateArtifacts();
        }

        public void Login(LoginConf login)
        {
            account = new Account(this,login);
            Account.singleton = account;
            this.DataContext = this.account;
            GlobalDefinition.SetupDockStations();
            account.windowList = windowList;
            this.loginTab.Visibility = Visibility.Collapsed;
            this.peopleTab.Visibility = Visibility.Visible;
            this.artefactTab.Visibility = Visibility.Visible;
            this.localeTab.Visibility = Visibility.Visible;
            this.meTab.Visibility = Visibility.Visible;
            this.tabs.SelectedItem = meTab;
            if (webCam.hasWebCam)
            {
                webCamState.SelectedItem = webCamEnabled;
            }
            else
            {
                webCamState.SelectedItem = webCamDisabled;
                webCam.Visibility = Visibility.Collapsed;
                webCamState.Items.Remove(webCamEnabled);
            }
        }

        public void AddPerson(Person person)
        {
            /*MediaItem item = new MediaItem();
            MediaItemContract.IPersonItem personItem = Account.singleton.itemLoader.CreatePersonItem(0);
            //Console.WriteLine("personItem loaded");
            personItem.StartItem(Account.singleton.sd, "/people/"+person.guid);
            //Console.WriteLine("personItem started");
            //item.SetMediaItem(new PresenceItem(person));
            item.SetMediaItem(personItem, person);*/
            MediaItem item = person.createMediaItem();
            item.Width = defaultThumbnailSize;
            item.Height = defaultThumbnailSize;
            item.Margin = new Thickness(defaultItemMargin);
            item.VerticalAlignment = VerticalAlignment.Top;
            item.MouseLeftButtonDown += new MouseButtonEventHandler(PeopleThumbnailItem_MouseLeftButtonDown);
            peopleThumbnailWrap.Children.Add(item);
        }

        public void RemovePerson(Person person)
        {
            MediaItem itemToRemove = null;
            Panel panel = null;
            foreach (MediaItem item in peopleIconWrap.Children)
            {
                if (item.member == person)
                {
                    itemToRemove = item;
                    panel = peopleIconWrap;
                    break;
                }
            }

            if (itemToRemove == null && panel == null)
            {
                foreach (MediaItem item in peopleThumbnailWrap.Children)
                {
                    if (item.member == person)
                    {
                        itemToRemove = item;
                        panel = peopleThumbnailWrap;
                        break;
                    }
                }
            }
            panel.Children.Remove(itemToRemove);
        }


        private void PopulateArtifacts()
        {
            /*WebPage webPage = new WebPage(null, DataStore.sd, "http://www.google.ca");
            account.artifacts.AddNewArtifact(webPage);
            AddArtifact(webPage);
            WebPage webPage1 = new WebPage(null, DataStore.sd, "http://www.ucalgary.ca");
            account.artifacts.AddNewArtifact(webPage1);
            AddArtifact(webPage1);
            WebPage webPage2 = new WebPage(null, DataStore.sd, "http://www.cpsc.ucalgary.ca");
            account.artifacts.AddNewArtifact(webPage2);
            AddArtifact(webPage2);*/
            /*Artifact artifact = Account.singleton.artifacts.CreateArtifact();
            account.artifacts.AddNewArtifact(artifact);
            AddArtifact(artifact);*/
        }

        /*public void AddArtifact(Artifact artifact)
        {
            MediaItem item = new MediaItem();
            MediaItemContract.IArtifactItem artifactItem = Account.singleton.itemLoader.CreateArtifactItem(0);
            //item.SetMediaItem(new PresenceItem(person));
            PersonHelper personHelper = new PersonHelper(Account.singleton.sd, Account.singleton.guid);
            artifactItem.StartItem(Account.singleton.sd, "/artifacts/" + artifact.guid, null, personHelper);
            //item.SetMediaItem(new WebItem(artifact as WebPage));
            item.SetMediaItem(artifactItem, artifact);
            //Console.WriteLine("after item");
            item.Width = defaultThumbnailSize;
            item.Height = defaultThumbnailSize;
            item.Margin = new Thickness(defaultItemMargin);
            item.VerticalAlignment = VerticalAlignment.Top;
            item.MouseLeftButtonDown += new MouseButtonEventHandler(ArtefactThumbnailItem_MouseLeftButtonDown);
            artefactThumbnailWrap.Children.Add(item);
        }*/

        public void AddArtifact(Plugin plugin, IDataObject droppedData)
        {
            Artifact artifact = Account.singleton.artifacts.CreateArtifact(plugin);
            account.artifacts.AddNewArtifact(artifact);
            /*MediaItem item = new MediaItem();
            MediaItemContract.IArtifactItem artifactItem = plugin.CreatePlugin() as IArtifactItem;
            PersonHelper personHelper = new PersonHelper(Account.singleton.sd, Account.singleton.guid);
            artifactItem.StartItem(Account.singleton.sd, "/artifacts/" + artifact.guid, null, personHelper);
            item.SetMediaItem(artifactItem, artifact);*/
            MediaItem item = artifact.createMediaItem();
            if (droppedData != null)
            {
                item.DropDataObject(droppedData);
            }
            item.Width = defaultThumbnailSize;
            item.Height = defaultThumbnailSize;
            item.Margin = new Thickness(defaultItemMargin);
            item.VerticalAlignment = VerticalAlignment.Top;
            item.MouseLeftButtonDown += new MouseButtonEventHandler(ArtefactThumbnailItem_MouseLeftButtonDown);
            artefactThumbnailWrap.Children.Add(item);
        }

        public void AddLocaleThumbnail(LocaleThumbnailItem item)
        {
            myLocales.AddToThumbnailPanel(item);
        }

        public void AddLocaleTile(LocaleTileItem item)
        {
            myLocales.AddToTilePanel(item);
        }
        public void RemoveLocaleThumbnail(Locale locale)
        {
            myLocales.RemoveLocale(locale);
        }

        private void PeopleIconItem_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            MediaItem item = sender as MediaItem;

            Point point = this.PointToScreen(e.GetPosition(this));

            HitMediaItem(peopleIconWrap, item, point);
            e.Handled = true;
        }

        private void PeopleThumbnailItem_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            MediaItem item = sender as MediaItem;

            Point point = this.PointToScreen(e.GetPosition(this));

            HitMediaItem(peopleThumbnailWrap, item, point);
            e.Handled = true;
        }

        private void ArtefactIconItem_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            MediaItem item = sender as MediaItem;

            Point point = this.PointToScreen(e.GetPosition(this));

            HitMediaItem(artefactIconWrap, item, point);
            e.Handled = true;
        }

        private void ArtefactThumbnailItem_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            MediaItem item = sender as MediaItem;

            Point point = this.PointToScreen(e.GetPosition(this));

            HitMediaItem(artefactThumbnailWrap, item, point);
            e.Handled = true;
        }

        private void HitMediaItem(Panel panel, MediaItem item, Point mPoint)
        {
            int index = panel.Children.IndexOf(item);
            //movingItem = panel.Children[index] as MediaItem;
            //movingItem = new MediaItem();
            //movingItem.SetMediaItem((IItem)((IItem)item.GetMediaItem()).Clone());
            movingItem = item.Clone() as MediaItem;
            movingItem.Width = item.Width;
            movingItem.Height = item.Height;
            movingItem.Margin = item.Margin;
            //Point point = movingItem.PointToScreen(new Point(0, 0));
            Point point = item.PointToScreen(new Point(0, 0));
            /*movingItem.ToBeDetachedFromContainer();
            panel.Children.RemoveAt(index);

            panel.Children.Insert(index, placeHolder);*/
            overIndex = index;
            hitIndex = index;
            //placeHolder.Height = defaultThumbnailSize;
            movingWindow = new ItemWindow();
            //movingWindow.Width = movingItem.ActualWidth + movingItem.Margin.Left + movingItem.Margin.Right;
            //movingWindow.Height = movingItem.ActualHeight + movingItem.Margin.Top + movingItem.Margin.Bottom;
            movingWindow.Width = movingItem.Width + movingItem.Margin.Left + movingItem.Margin.Right;
            movingWindow.Height = movingItem.Height + movingItem.Margin.Top + movingItem.Margin.Bottom;

            movingWindow.Top = point.Y - movingItem.Margin.Top;
            movingWindow.Left = point.X - movingItem.Margin.Left;
            movingWindow.SetItem(movingItem);
            movingItem.isInWindow = true;

            dx = mPoint.X - movingWindow.Left;
            dy = mPoint.Y - movingWindow.Top;
            //Console.WriteLine(dx + "=" + mPoint.X + "-" + movingWindow.Left);
            isDragging = true;
            focusPanel = panel;
            hitPanel = panel;
            movingWindow.Show();
            //movingWindow.Owner = this;
            movingWindow.myOwner = this;
            //movingItem.AttachedToOverlay();
            Mouse.Capture(panel);
        }

        private void peopleIconWrap_MouseMove(object sender, MouseEventArgs e)
        {
            if (isDragging)
            {
                Point point = this.PointToScreen(e.GetPosition(this));
                movingWindow.Left = point.X - dx;
                movingWindow.Top = point.Y - dy;

                if (isOutOfBound(contactViewer,point))
                {
                    movingItem.MouseLeftButtonDown -= new MouseButtonEventHandler(PeopleIconItem_MouseLeftButtonDown);
                    /*movingItem.MouseMove -= new MouseEventHandler(IconItem_MouseMove);
                    movingItem.MouseLeave -= new MouseEventHandler(IconItem_MouseLeave);
                    movingItem.MouseWheel -= new MouseWheelEventHandler(IconItem_MouseWheel);
                    movingItem.MouseRightButtonDown -= new MouseButtonEventHandler(IconItem_MouseRightButtonDown);*/
                    isDragging = false;
                    Mouse.Capture(null);
                    movingItem.Width = defaultInWindowSize;
                    movingItem.Height = defaultInWindowSize;
                    movingWindow.Width = movingItem.Width + movingItem.Margin.Left + movingItem.Margin.Right;
                    movingWindow.Height = movingItem.Height + movingItem.Margin.Top + movingItem.Margin.Bottom;
                    movingWindow.dx = this.dx * (movingWindow.Width / (currentIconSize + defaultItemMargin*2));
                    movingWindow.dy = this.dy * (movingWindow.Height / (currentIconSize + defaultItemMargin * 2));
                    windowList.Add(movingWindow);
                    movingWindow.StartDragging(point);
                    movingWindow.SetGrip();
                    movingWindow.SetOpacity(0.7);
                    insertIndicator.Visibility = Visibility.Hidden;
                    hitPanel = null;
                    hitIndex = -1;
                    e.Handled = true;
                    return;
                }
                else if (!isInPeopleIcon(point))
                {
                    focusPanel = peopleThumbnailWrap;
                    overIndex = peopleThumbnailWrap.Children.Count;

                    movingItem.Width = defaultThumbnailSize;
                    movingItem.Height = defaultThumbnailSize;
                    movingWindow.Width = movingItem.Width + movingItem.Margin.Left + movingItem.Margin.Right;
                    movingWindow.Height = movingItem.Height + movingItem.Margin.Top + movingItem.Margin.Bottom;

                    dy *= defaultThumbnailSize / currentIconSize;
                    dx *= defaultThumbnailSize / currentIconSize;
                    movingItem.MouseLeftButtonDown -= new MouseButtonEventHandler(PeopleIconItem_MouseLeftButtonDown);
                    /*movingItem.MouseMove -= new MouseEventHandler(IconItem_MouseMove);
                    movingItem.MouseLeave -= new MouseEventHandler(IconItem_MouseLeave);
                    movingItem.MouseWheel -= new MouseWheelEventHandler(IconItem_MouseWheel);
                    movingItem.MouseRightButtonDown -= new MouseButtonEventHandler(IconItem_MouseRightButtonDown);*/
                    movingItem.MouseLeftButtonDown += new MouseButtonEventHandler(PeopleThumbnailItem_MouseLeftButtonDown);
                    /*movingItem.MouseMove += new MouseEventHandler(MediaItem_MouseMove);
                    movingItem.MouseLeave += new MouseEventHandler(MediaItem_MouseLeave);
                    movingItem.MouseWheel += new MouseWheelEventHandler(MediaItem_MouseWheel);
                    movingItem.MouseRightButtonDown += new MouseButtonEventHandler(MediaItem_MouseRightButtonDown);*/
                    //Mouse.Capture(thumbnailStack, CaptureMode.SubTree);
                    Mouse.Capture(peopleThumbnailWrap);
                    e.Handled = true;
                    return;
                }
                else
                {
                    Point p = e.GetPosition(this.contactViewer);
                    //Console.WriteLine(p);
                    if (p.Y < 20)
                    {
                        insertIndicator.Visibility = Visibility.Hidden;
                        contactViewer.LineUp();
                    }
                    else if (p.Y > contactViewer.ActualHeight - 20)
                    {
                        insertIndicator.Visibility = Visibility.Hidden;
                        contactViewer.LineDown();
                    }
                    WrapItemIndexUpdate(peopleIconWrap, point);
                }
                e.Handled = true;
            }
        }

        private void peopleThumbnailWrap_MouseMove(object sender, MouseEventArgs e)
        {
            if (isDragging)
            {
                Point point = this.PointToScreen(e.GetPosition(this));
                movingWindow.Left = point.X - dx;
                movingWindow.Top = point.Y - dy;
 
                if (isOutOfBound(contactViewer,point))
                {
                    //Console.WriteLine("Draging out");
                    isDragging = false;
                    Mouse.Capture(null);
                    //peopleThumbnailWrap.Children.Remove(placeHolder);
                    //peopleIconWrap.Children.Remove()
                    movingItem.MouseLeftButtonDown -= new MouseButtonEventHandler(PeopleThumbnailItem_MouseLeftButtonDown);
                    /*movingItem.MouseMove -= new MouseEventHandler(MediaItem_MouseMove);
                    movingItem.MouseLeave -= new MouseEventHandler(MediaItem_MouseLeave);
                    movingItem.MouseWheel -= new MouseWheelEventHandler(MediaItem_MouseWheel);
                    movingItem.MouseRightButtonDown -= new MouseButtonEventHandler(MediaItem_MouseRightButtonDown);*/
                    movingItem.Width = defaultInWindowSize;
                    movingItem.Height = defaultInWindowSize;
                    movingWindow.Width = movingItem.Width + movingItem.Margin.Left + movingItem.Margin.Right;
                    movingWindow.Height = movingItem.Height + movingItem.Margin.Top + movingItem.Margin.Bottom;
                    movingWindow.dx = this.dx * (movingWindow.Width / (defaultThumbnailSize + defaultItemMargin*2));
                    movingWindow.dy = this.dy * (movingItem.Height / (defaultThumbnailSize + defaultItemMargin * 2));

                    windowList.Add(movingWindow);
                    //Console.WriteLine("start draging");
                    movingWindow.StartDragging(point);
                    //movingWindow.DragMove();
                    movingWindow.SetGrip();
                    movingWindow.SetOpacity(0.7);
                    insertIndicator.Visibility = Visibility.Hidden;
                    hitPanel = null;
                    hitIndex = -1;
                    e.Handled = true;
                    //Console.WriteLine("Drag out from thumbnail");
                    return;
                }
                else if (isInPeopleIcon(point))
                {

                    focusPanel = peopleIconWrap;
                    overIndex = peopleIconWrap.Children.Count;

                    movingItem.Width = currentIconSize;
                    movingItem.Height = currentIconSize;
                    movingWindow.Width = movingItem.Width + movingItem.Margin.Left + movingItem.Margin.Right;
                    movingWindow.Height = movingItem.Height + movingItem.Margin.Top + movingItem.Margin.Bottom;

                    dx = dx / (defaultThumbnailSize / currentIconSize);
                    dy = dy / (defaultThumbnailSize / currentIconSize);
                    movingItem.MouseLeftButtonDown -= new MouseButtonEventHandler(PeopleThumbnailItem_MouseLeftButtonDown);
                    /*movingItem.MouseMove -= new MouseEventHandler(MediaItem_MouseMove);
                    movingItem.MouseLeave -= new MouseEventHandler(MediaItem_MouseLeave);
                    movingItem.MouseWheel -= new MouseWheelEventHandler(MediaItem_MouseWheel);
                    movingItem.MouseRightButtonDown -= new MouseButtonEventHandler(MediaItem_MouseRightButtonDown);*/
                    movingItem.MouseLeftButtonDown += new MouseButtonEventHandler(PeopleIconItem_MouseLeftButtonDown);
                    /*movingItem.MouseMove += new MouseEventHandler(IconItem_MouseMove);
                    movingItem.MouseLeave += new MouseEventHandler(IconItem_MouseLeave);
                    movingItem.MouseWheel += new MouseWheelEventHandler(IconItem_MouseWheel);
                    movingItem.MouseRightButtonDown += new MouseButtonEventHandler(IconItem_MouseRightButtonDown);*/
                    //Mouse.Capture(iconStack, CaptureMode.SubTree);
                    Mouse.Capture(peopleIconWrap);
                    e.Handled = true;
                    return;
                }
                else
                {
                    Point p = e.GetPosition(this.contactViewer);
                    //Console.WriteLine(p);
                    if (p.Y < 20)
                    {
                        insertIndicator.Visibility = Visibility.Hidden;
                        contactViewer.LineUp();
                    }
                    else if (p.Y > contactViewer.ActualHeight - 20)
                    {
                        insertIndicator.Visibility = Visibility.Hidden;
                        contactViewer.LineDown();
                    }
                    WrapItemIndexUpdate(peopleThumbnailWrap, point);
                }
                e.Handled = true;
            }
        }

        private void artefactIconWrap_MouseMove(object sender, MouseEventArgs e)
        {
            if (isDragging)
            {
                Point point = this.PointToScreen(e.GetPosition(this));
                movingWindow.Left = point.X - dx;
                movingWindow.Top = point.Y - dy;

                if (isOutOfBound(artefactViewer,point))
                {
                    movingItem.MouseLeftButtonDown -= new MouseButtonEventHandler(ArtefactIconItem_MouseLeftButtonDown);
                    /*movingItem.MouseMove -= new MouseEventHandler(IconItem_MouseMove);
                    movingItem.MouseLeave -= new MouseEventHandler(IconItem_MouseLeave);
                    movingItem.MouseWheel -= new MouseWheelEventHandler(IconItem_MouseWheel);
                    movingItem.MouseRightButtonDown -= new MouseButtonEventHandler(IconItem_MouseRightButtonDown);*/
                    isDragging = false;
                    Mouse.Capture(null);
                    movingItem.Width = defaultInWindowSize;
                    movingItem.Height = defaultInWindowSize;
                    movingWindow.Width = movingItem.Width + movingItem.Margin.Left + movingItem.Margin.Right;
                    movingWindow.Height = movingItem.Height + movingItem.Margin.Top + movingItem.Margin.Bottom;
                    movingWindow.dx = this.dx * (movingWindow.Width / (currentIconSize + defaultItemMargin * 2));
                    movingWindow.dy = this.dy * (movingWindow.Height / (currentIconSize + defaultItemMargin * 2));
                    windowList.Add(movingWindow);
                    movingWindow.StartDragging(point);
                    movingWindow.SetGrip();
                    movingWindow.SetOpacity(0.7);
                    insertIndicator.Visibility = Visibility.Hidden;
                    hitPanel = null;
                    hitIndex = -1;
                    e.Handled = true;
                    return;
                }
                else if (!isInArtefactIcon(point))
                {
                    focusPanel = artefactThumbnailWrap;
                    overIndex = artefactThumbnailWrap.Children.Count;

                    movingItem.Width = defaultThumbnailSize;
                    movingItem.Height = defaultThumbnailSize;
                    movingWindow.Width = movingItem.Width + movingItem.Margin.Left + movingItem.Margin.Right;
                    movingWindow.Height = movingItem.Height + movingItem.Margin.Top + movingItem.Margin.Bottom;

                    dy *= defaultThumbnailSize / currentIconSize;
                    dx *= defaultThumbnailSize / currentIconSize;
                    movingItem.MouseLeftButtonDown -= new MouseButtonEventHandler(ArtefactIconItem_MouseLeftButtonDown);
                    /*movingItem.MouseMove -= new MouseEventHandler(IconItem_MouseMove);
                    movingItem.MouseLeave -= new MouseEventHandler(IconItem_MouseLeave);
                    movingItem.MouseWheel -= new MouseWheelEventHandler(IconItem_MouseWheel);
                    movingItem.MouseRightButtonDown -= new MouseButtonEventHandler(IconItem_MouseRightButtonDown);*/
                    movingItem.MouseLeftButtonDown += new MouseButtonEventHandler(ArtefactThumbnailItem_MouseLeftButtonDown);
                    /*movingItem.MouseMove += new MouseEventHandler(MediaItem_MouseMove);
                    movingItem.MouseLeave += new MouseEventHandler(MediaItem_MouseLeave);
                    movingItem.MouseWheel += new MouseWheelEventHandler(MediaItem_MouseWheel);
                    movingItem.MouseRightButtonDown += new MouseButtonEventHandler(MediaItem_MouseRightButtonDown);*/
                    //Mouse.Capture(thumbnailStack, CaptureMode.SubTree);
                    Mouse.Capture(artefactThumbnailWrap);
                    e.Handled = true;
                    return;
                }
                else
                {
                    Point p = e.GetPosition(this.artefactViewer);
                    //Console.WriteLine(p);
                    if (p.Y < 20)
                    {
                        insertIndicator.Visibility = Visibility.Hidden;
                        artefactViewer.LineUp();
                    }
                    else if (p.Y > artefactViewer.ActualHeight - 20)
                    {
                        insertIndicator.Visibility = Visibility.Hidden;
                        artefactViewer.LineDown();
                    }
                    WrapItemIndexUpdate(artefactIconWrap, point);
                }
                e.Handled = true;
            }
        }

        private void artefactThumbnailWrap_MouseMove(object sender, MouseEventArgs e)
        {
            if (isDragging)
            {
                Point point = this.PointToScreen(e.GetPosition(this));
                movingWindow.Left = point.X - dx;
                movingWindow.Top = point.Y - dy;

                if (isOutOfBound(artefactViewer, point))
                {
                    isDragging = false;
                    Mouse.Capture(null);

                    movingItem.MouseLeftButtonDown -= new MouseButtonEventHandler(ArtefactThumbnailItem_MouseLeftButtonDown);
                    /*movingItem.MouseMove -= new MouseEventHandler(MediaItem_MouseMove);
                    movingItem.MouseLeave -= new MouseEventHandler(MediaItem_MouseLeave);
                    movingItem.MouseWheel -= new MouseWheelEventHandler(MediaItem_MouseWheel);
                    movingItem.MouseRightButtonDown -= new MouseButtonEventHandler(MediaItem_MouseRightButtonDown);*/
                    movingItem.Width = defaultInWindowSize;
                    movingItem.Height = defaultInWindowSize;
                    movingWindow.Width = movingItem.Width + movingItem.Margin.Left + movingItem.Margin.Right;
                    movingWindow.Height = movingItem.Height + movingItem.Margin.Top + movingItem.Margin.Bottom;
                    movingWindow.dx = this.dx * (movingWindow.Width / (defaultThumbnailSize + defaultItemMargin * 2));
                    movingWindow.dy = this.dy * (movingItem.Height / (defaultThumbnailSize + defaultItemMargin * 2));

                    windowList.Add(movingWindow);
                    movingWindow.StartDragging(point);
                    //movingWindow.DragMove();
                    movingWindow.SetGrip();
                    movingWindow.SetOpacity(0.7);
                    insertIndicator.Visibility = Visibility.Hidden;
                    hitPanel = null;
                    hitIndex = -1;
                    e.Handled = true;
                    return;
                }
                else if (isInArtefactIcon(point))
                {
                    focusPanel = artefactIconWrap;
                    overIndex = artefactIconWrap.Children.Count;

                    movingItem.Width = currentIconSize;
                    movingItem.Height = currentIconSize;
                    movingWindow.Width = movingItem.Width + movingItem.Margin.Left + movingItem.Margin.Right;
                    movingWindow.Height = movingItem.Height + movingItem.Margin.Top + movingItem.Margin.Bottom;

                    dx = dx / (defaultThumbnailSize / currentIconSize);
                    dy = dy / (defaultThumbnailSize / currentIconSize);
                    movingItem.MouseLeftButtonDown -= new MouseButtonEventHandler(ArtefactThumbnailItem_MouseLeftButtonDown);
                    /*movingItem.MouseMove -= new MouseEventHandler(MediaItem_MouseMove);
                    movingItem.MouseLeave -= new MouseEventHandler(MediaItem_MouseLeave);
                    movingItem.MouseWheel -= new MouseWheelEventHandler(MediaItem_MouseWheel);
                    movingItem.MouseRightButtonDown -= new MouseButtonEventHandler(MediaItem_MouseRightButtonDown);*/
                    movingItem.MouseLeftButtonDown += new MouseButtonEventHandler(ArtefactIconItem_MouseLeftButtonDown);
                    /*movingItem.MouseMove += new MouseEventHandler(IconItem_MouseMove);
                    movingItem.MouseLeave += new MouseEventHandler(IconItem_MouseLeave);
                    movingItem.MouseWheel += new MouseWheelEventHandler(IconItem_MouseWheel);
                    movingItem.MouseRightButtonDown += new MouseButtonEventHandler(IconItem_MouseRightButtonDown);*/
                    //Mouse.Capture(iconStack, CaptureMode.SubTree);
                    Mouse.Capture(artefactIconWrap);
                    e.Handled = true;
                    return;
                }
                else
                {
                    Point p = e.GetPosition(this.artefactViewer);
                    //Console.WriteLine(p);
                    if (p.Y < 20)
                    {
                        insertIndicator.Visibility = Visibility.Hidden;
                        artefactViewer.LineUp();
                    }
                    else if (p.Y > artefactViewer.ActualHeight - 20)
                    {
                        insertIndicator.Visibility = Visibility.Hidden;
                        artefactViewer.LineDown();
                    }
                    WrapItemIndexUpdate(artefactThumbnailWrap, point);
                }
                e.Handled = true;
            }
        }

        /*public bool isOutOfBound(Point point)
        {
            if (point.X < this.Left || point.X > this.Left + this.ActualWidth || point.Y < this.Top || point.Y > this.Top + this.ActualHeight)
            {
                return true;
            }
            return false;
        }*/

        public bool isOutOfBound(Point point)
        {
            if (peopleTab.IsSelected)
            {
                return isOutOfBound(contactViewer, point);
            }
            else if (artefactTab.IsSelected)
            {
                return isOutOfBound(artefactViewer, point);
            }
            return true;
        }

        public bool isOutOfBound(ScrollViewer viewer, Point point)
        {
            Point p = viewer.PointToScreen(new Point(0, 0));
            if (point.X < p.X || point.X > p.X + viewer.ActualWidth || point.Y < p.Y || point.Y > p.Y + viewer.ActualHeight)
            {
                return true;
            }
            return false;
        }

        /*private bool isThumbnail(Point point)
        {
            Point p = peopleThumbnailWrap.PointToScreen(new Point(0, 0));
            if (point.Y > p.Y - peopleThumbnailWrap.Margin.Top)
            {
                return true;
            }
            return false;
        }*/

        private bool isInPeopleIcon(Point point)
        {
            Point p = peopleIconWrap.PointToScreen(new Point(0, 0));
            if (point.Y > p.Y - peopleIconWrap.Margin.Top)
            {
                return true;
            }
            return false;
        }

        private bool isInArtefactIcon(Point point)
        {
            Point p = artefactIconWrap.PointToScreen(new Point(0, 0));
            if (point.Y > p.Y - artefactIconWrap.Margin.Top)
            {
                return true;
            }
            return false;
        }

        private void WrapItemIndexUpdate(WrapPanel wrap, Point point)
        {
            if (isDragging)
            {
                if (overIndex < wrap.Children.Count)
                {
                    MediaItem overItem = wrap.Children[overIndex] as MediaItem;
                    Point oPoint = overItem.PointToScreen(new Point(0, 0));
                    //oPoint.X -= defaultItemMargin;
                    if (point.X >= oPoint.X - overItem.Margin.Left && point.X <= oPoint.X + overItem.Width + overItem.Margin.Right && point.Y >= oPoint.Y - overItem.Margin.Top && point.Y <= oPoint.Y + overItem.Height + overItem.Margin.Bottom)
                    {
                        return;
                    }
                }
                int index = 0;
                foreach (MediaItem item in wrap.Children)
                {
                    /*if (item.Width == defaultItemMargin)
                    {
                        continue;
                    }*/
                    Point p = item.PointToScreen(new Point(0, 0));
                    if (point.X >= p.X - item.Margin.Left && point.X <= p.X + item.Width + item.Margin.Right && point.Y >= p.Y - item.Margin.Top && point.Y <= p.Y + item.Height + item.Margin.Bottom)
                    {
                        
                        /*if (overIndex < wrap.Children.Count)
                        {
                            wrap.Children.Remove(placeHolder);
                        }
                        wrap.Children.Insert(index, placeHolder);*/
                        /*if (hitPanel == peopleIconWrap)
                        {
                            Console.WriteLine("Icon Panel " + hitIndex);
                        }
                        else if (hitPanel == peopleThumbnailWrap)
                        {
                            Console.WriteLine("Thumbnail Panel " + hitIndex);
                        }
                        else
                        {
                            Console.WriteLine("What the fuck");
                        }*/
                        if (focusPanel == hitPanel && index == hitIndex)
                        {
                            insertIndicator.Visibility = Visibility.Hidden;
                            //insertIndicator.Hide();
                            //remove
                            /*MediaItem overItem = wrap.Children[overIndex] as MediaItem;
                            overItem.Margin = new Thickness(defaultItemMargin);
                            wrap.Children.Remove(placeHolder);
                            int realIndex = wrap.Children.IndexOf(item);
                            overIndex = realIndex;*/
                        }
                        else
                        {
                            /*if (hitPanel == peopleIconWrap)
                            {
                                Console.WriteLine("Icon Panel " + hitIndex);
                            }
                            else if (hitPanel == peopleThumbnailWrap)
                            {
                                Console.WriteLine("Thumbnail Panel " + hitIndex);
                            }*/
                            ScrollViewer viewer;
                            if (wrap == peopleIconWrap || wrap == peopleThumbnailWrap)
                            {
                                viewer = contactViewer;
                            }
                            else
                            {
                                viewer = artefactViewer;
                            }
                            
                            Point viewerPoint = viewer.PointToScreen(new Point(0, 0));
                            insertIndicator.Left = p.X - defaultItemMargin;
                            insertIndicator.Top = p.Y;
                            insertIndicator.Height = item.Height;
                            if (p.Y < viewerPoint.Y)
                            {
                                insertIndicator.Top = viewerPoint.Y;
                                insertIndicator.Height = item.Height - (viewerPoint.Y - p.Y);
                            }
                            else if (p.Y + item.Height> viewerPoint.Y + viewer.ActualHeight)
                            {
                                insertIndicator.Height = (viewerPoint.Y + viewer.ActualHeight) - p.Y;
                            }

   
                            insertIndicator.Visibility = Visibility.Visible;
                            GlobalDefinition.Focus(movingWindow);

                            //remove
                            /*MediaItem overItem = wrap.Children[overIndex] as MediaItem;
                            overItem.Margin = new Thickness(defaultItemMargin);
                            wrap.Children.Remove(placeHolder);
                            //insert
                            int realIndex = wrap.Children.IndexOf(item);
                            item.Margin = new Thickness(0, 2, 2, 2);
                            wrap.Children.Insert(realIndex, placeHolder);
                            overIndex = realIndex + 1;*/

                        }
                        overIndex = index;
                        break;
                    }
                    index++;
                }
                /*if (index == wrap.Children.Count)
                {
                    if (!wrap.Children.Contains(placeHolder))
                    {
                        wrap.Children.Add(placeHolder);
                        overIndex = index;

                        //System.Console.WriteLine("what"+index);
                    }
                }*/
                //UpdateDimensions();
            }

        }

        private void peopleStack_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            if (isDragging)
            {
                DropMediaItem(e);
                insertIndicator.Visibility = Visibility.Hidden;
                e.Handled = true;
            }
        }

        private void FindPersonHitPlace(Person person, ref Panel panel, ref int index)
        {
            foreach (MediaItem mediaItem in peopleIconWrap.Children)
            {
                //PresenceItem item = mediaItem.mediaItem as PresenceItem;
                if(mediaItem.member == person) //if (item.person == person)
                {
                    panel = peopleIconWrap;
                    index = peopleIconWrap.Children.IndexOf(mediaItem);
                    return;
                }
            }
            foreach (MediaItem mediaItem in peopleThumbnailWrap.Children)
            {
                //PresenceItem item = mediaItem.mediaItem as PresenceItem;
                if (mediaItem.member == person) //if (item.person == person)
                {
                    panel = peopleThumbnailWrap;
                    index = peopleThumbnailWrap.Children.IndexOf(mediaItem);
                    return;
                }
            }
            panel = null;
            index = -1;
        }

        private void FindArtefactHitPlace(Artifact artifact, ref Panel panel, ref int index)
        {
            foreach (MediaItem mediaItem in artefactIconWrap.Children)
            {
                //WebItem item = mediaItem.mediaItem as WebItem;
                if (mediaItem.member == artifact) //if (item.webPage == artifact)
                {
                    panel = artefactIconWrap;
                    index = artefactIconWrap.Children.IndexOf(mediaItem);
                    return;
                }
            }
            foreach (MediaItem mediaItem in artefactThumbnailWrap.Children)
            {
                //WebItem item = mediaItem.mediaItem as WebItem;
                if (mediaItem.member == artifact) //if (item.webPage == artifact)
                {
                    panel = artefactThumbnailWrap;
                    index = artefactThumbnailWrap.Children.IndexOf(mediaItem);
                    return;
                }
            }
            panel = null;
            index = -1;
        }

        private void DropMediaItem(MouseButtonEventArgs e)
        {
            Panel panel = focusPanel as Panel;
            //movingItem = movingWindow.mediaItem;
            //movingItem.Height = placeHolder.Height;
            //movingItem.Width = placeHolder.Width;

            if (hitPanel == panel && hitIndex == overIndex)
            {
                
                movingWindow.Close();
                movingItem = null;
                isDragging = false;
                Mouse.Capture(null);
                return;
            }
            if (panel == peopleIconWrap || panel == artefactIconWrap)
            {
                movingItem.Height = currentIconSize;
                movingItem.Width = currentIconSize;
            }
            else
            {
                movingItem.Height = defaultThumbnailSize;
                movingItem.Width = defaultThumbnailSize;
            }
            
            //panel.Children.Remove(placeHolder);
            hitPanel.Children.RemoveAt(hitIndex);
            movingWindow.SetItem(null);
            movingItem.isInWindow = false;
            if (overIndex < panel.Children.Count)
            {
                panel.Children.Insert(overIndex, movingItem);
            }
            else
            {
                panel.Children.Add(movingItem);
            }
            //movingWindow.Hide();
            movingWindow.Close();
            isDragging = false;
            hitPanel = null;
            hitIndex = -1;
            Mouse.Capture(null);
        }

        public void DragIn(Point mPoint, ItemWindow movingWindow)
        {
            MediaItem mediaItem = movingWindow.mediaItem;
            if (mediaItem.mediaItem is IPersonItem)
            {
                //peopleTab.IsSelected = true;
                if (tabs.SelectedIndex != 1)
                {
                    tabs.SelectedIndex = 1;
                    tabs.UpdateLayout();
                }
                //PresenceItem item = mediaItem.mediaItem as PresenceItem;
                //Person person = item.person;
                Person person = mediaItem.member as Person;
                FindPersonHitPlace(person, ref hitPanel, ref hitIndex);
                PeopleDragIn(mPoint, movingWindow);
            }
            else
            {
                //artefactTab.IsSelected = true;
                //Console.WriteLine("selected tab " + tabs.SelectedIndex);
                if (tabs.SelectedIndex != 2)
                {
                    tabs.SelectedIndex = 2;
                    tabs.UpdateLayout();
                }
                //WebItem item = mediaItem.mediaItem as WebItem;
                //WebPage page = item.webPage;
                Artifact artifact = mediaItem.member as Artifact;
                FindArtefactHitPlace(artifact, ref hitPanel, ref hitIndex);
                ArtefactDragIn(mPoint, movingWindow);
            }
            /*if (peopleTab.IsSelected)
            {
                PeopleDragIn(mPoint, movingWindow);
            }
            else if (artefactTab.IsSelected)
            {
                ArtefactDragIn(mPoint, movingWindow);
            }
            if (hitPanel == null || hitIndex == -1)
            {
                Console.WriteLine("It is right");
                if (movingItem.mediaItem is PresenceItem)
                {
                    PresenceItem item = movingItem.mediaItem as PresenceItem;
                    Person person = item.person;
                    FindPersonHitPlace(person, ref hitPanel, ref hitIndex);
                }
                else
                {
                    WebItem item = movingItem.mediaItem as WebItem;
                    WebPage page = item.webPage;
                    FindArtefactHitPlace(page, ref hitPanel, ref hitIndex);
                }
            }
            if (hitPanel == null || hitIndex == -1)
            {
                Console.WriteLine("It is not right");
            }*/
            /*if (hitPanel == peopleIconWrap)
            {
                Console.WriteLine("Icon Panel " + hitIndex);
            }
            else if (hitPanel == peopleThumbnailWrap)
            {
                Console.WriteLine("Thumbnail Panel " + hitIndex);
            }*/
        }

        public void PeopleDragIn(Point mPoint, ItemWindow movingWindow)
        {
            if (isInPeopleIcon(mPoint))
            {
                focusPanel = peopleIconWrap;
                overIndex = peopleIconWrap.Children.Count;
                //currentIconSize = 16;
                //placeHolder.Width = currentIconSize;
                //placeHolder.Height = currentIconSize;

                dx = movingWindow.dx / (movingWindow.Width / (currentIconSize + defaultItemMargin*2));
                dy = movingWindow.dy / (movingWindow.Height / (currentIconSize + defaultItemMargin * 2));

                movingItem = movingWindow.mediaItem;
                movingItem.Width = currentIconSize;
                movingItem.Height = currentIconSize;
                movingWindow.Width = movingItem.Width + movingItem.Margin.Left + movingItem.Margin.Right;
                movingWindow.Height = movingItem.Height + movingItem.Margin.Top + movingItem.Margin.Bottom;

                //movingItem.MouseLeftButtonDown -= new MouseButtonEventHandler(ThumbnailItem_MouseLeftButtonDown);
                movingItem.MouseLeftButtonDown += new MouseButtonEventHandler(PeopleIconItem_MouseLeftButtonDown);
                /*movingItem.MouseMove += new MouseEventHandler(IconItem_MouseMove);
                movingItem.MouseLeave += new MouseEventHandler(IconItem_MouseLeave);
                movingItem.MouseWheel += new MouseWheelEventHandler(IconItem_MouseWheel);
                movingItem.MouseRightButtonDown += new MouseButtonEventHandler(IconItem_MouseRightButtonDown);*/
                isDragging = true;
                //Mouse.Capture(iconStack, CaptureMode.SubTree);
                this.movingWindow = movingWindow;
                //this.movingItem = movingWindow.mediaItem;
                windowList.Remove(movingWindow);
                Mouse.Capture(peopleIconWrap);
            }
            else
            {
                focusPanel = peopleThumbnailWrap;
                overIndex = peopleThumbnailWrap.Children.Count;
                //placeHolder.Width = defaultThumbnailSize;
                //placeHolder.Height = defaultThumbnailSize;
                dx = movingWindow.dx / (movingWindow.Width / (defaultThumbnailSize + defaultItemMargin * 2));
                dy = movingWindow.dy / (movingWindow.Height / (defaultThumbnailSize + defaultItemMargin * 2));
                movingItem = movingWindow.mediaItem;
                movingItem.Width = defaultThumbnailSize;
                movingItem.Height = defaultThumbnailSize;
                movingWindow.Width = movingItem.Width + movingItem.Margin.Left + movingItem.Margin.Right;
                movingWindow.Height = movingItem.Height + movingItem.Margin.Top + movingItem.Margin.Bottom;

                //movingItem.MouseLeftButtonDown -= new MouseButtonEventHandler(IconItem_MouseLeftButtonDown);
                movingItem.MouseLeftButtonDown += new MouseButtonEventHandler(PeopleThumbnailItem_MouseLeftButtonDown);
                /*movingItem.MouseMove += new MouseEventHandler(MediaItem_MouseMove);
                movingItem.MouseLeave += new MouseEventHandler(MediaItem_MouseLeave);
                movingItem.MouseWheel += new MouseWheelEventHandler(MediaItem_MouseWheel);
                movingItem.MouseRightButtonDown += new MouseButtonEventHandler(MediaItem_MouseRightButtonDown);*/
                isDragging = true;
                //Mouse.Capture(thumbnailStack, CaptureMode.SubTree);
                this.movingWindow = movingWindow;
                //this.movingItem = movingWindow.mediaItem;
                windowList.Remove(movingWindow);
                Mouse.Capture(peopleThumbnailWrap);
            }
            movingWindow.RemoveGrip();
            movingWindow.SetOpacity(1);
        }

        public void ArtefactDragIn(Point mPoint, ItemWindow movingWindow)
        {
            if (isInArtefactIcon(mPoint))
            {
                focusPanel = artefactIconWrap;
                overIndex = artefactIconWrap.Children.Count;
                //currentIconSize = 16;
                //placeHolder.Width = currentIconSize;
                //placeHolder.Height = currentIconSize;

                dx = movingWindow.dx / (movingWindow.Width / (currentIconSize + defaultItemMargin * 2));
                dy = movingWindow.dy / (movingWindow.Height / (currentIconSize + defaultItemMargin * 2));

                movingItem = movingWindow.mediaItem;
                movingItem.Width = currentIconSize;
                movingItem.Height = currentIconSize;
                movingWindow.Width = movingItem.Width + movingItem.Margin.Left + movingItem.Margin.Right;
                movingWindow.Height = movingItem.Height + movingItem.Margin.Top + movingItem.Margin.Bottom;

                //movingItem.MouseLeftButtonDown -= new MouseButtonEventHandler(ThumbnailItem_MouseLeftButtonDown);
                movingItem.MouseLeftButtonDown += new MouseButtonEventHandler(ArtefactIconItem_MouseLeftButtonDown);
                /*movingItem.MouseMove += new MouseEventHandler(IconItem_MouseMove);
                movingItem.MouseLeave += new MouseEventHandler(IconItem_MouseLeave);
                movingItem.MouseWheel += new MouseWheelEventHandler(IconItem_MouseWheel);
                movingItem.MouseRightButtonDown += new MouseButtonEventHandler(IconItem_MouseRightButtonDown);*/
                isDragging = true;
                //Mouse.Capture(iconStack, CaptureMode.SubTree);
                this.movingWindow = movingWindow;
                //this.movingItem = movingWindow.mediaItem;
                windowList.Remove(movingWindow);
                Mouse.Capture(artefactIconWrap);
            }
            else
            {
                focusPanel = artefactThumbnailWrap;
                overIndex = artefactThumbnailWrap.Children.Count;
                //placeHolder.Width = defaultThumbnailSize;
                //placeHolder.Height = defaultThumbnailSize;
                dx = movingWindow.dx / (movingWindow.Width / (defaultThumbnailSize + defaultItemMargin * 2));
                dy = movingWindow.dy / (movingWindow.Height / (defaultThumbnailSize + defaultItemMargin * 2));
                movingItem = movingWindow.mediaItem;
                movingItem.Width = defaultThumbnailSize;
                movingItem.Height = defaultThumbnailSize;
                movingWindow.Width = movingItem.Width + movingItem.Margin.Left + movingItem.Margin.Right;
                movingWindow.Height = movingItem.Height + movingItem.Margin.Top + movingItem.Margin.Bottom;

                //movingItem.MouseLeftButtonDown -= new MouseButtonEventHandler(IconItem_MouseLeftButtonDown);
                movingItem.MouseLeftButtonDown += new MouseButtonEventHandler(ArtefactThumbnailItem_MouseLeftButtonDown);
                /*movingItem.MouseMove += new MouseEventHandler(MediaItem_MouseMove);
                movingItem.MouseLeave += new MouseEventHandler(MediaItem_MouseLeave);
                movingItem.MouseWheel += new MouseWheelEventHandler(MediaItem_MouseWheel);
                movingItem.MouseRightButtonDown += new MouseButtonEventHandler(MediaItem_MouseRightButtonDown);*/
                isDragging = true;
                //Mouse.Capture(thumbnailStack, CaptureMode.SubTree);
                this.movingWindow = movingWindow;
                //this.movingItem = movingWindow.mediaItem;
                windowList.Remove(movingWindow);
                Mouse.Capture(artefactThumbnailWrap);
            }
            movingWindow.RemoveGrip();
            movingWindow.SetOpacity(1);
        }

        private void artefactStack_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            if (isDragging)
            {
                DropMediaItem(e);
                insertIndicator.Visibility = Visibility.Hidden;
                e.Handled = true;
            }
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            Console.WriteLine("Window_Closing");
            if (account != null && account.sd != null)
            {
                account.sd.Close(true);
            }
            webCam.CleanWebCam();
        }

        private void webCamState_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (e.AddedItems.Contains(webCamEnabled))
            {
                this.webCam.Visibility = Visibility.Visible;
            }
            else
            {
                this.webCam.Visibility = Visibility.Collapsed;
            }
        }

        private void artefactViewer_Drop(object sender, DragEventArgs e)
        {
            //Console.WriteLine(e.Data.GetFormats());
            //this.dropPopup.IsOpen = true;
            //this.artefactMenu.PlacementTarget = this.artefactTab;
            //this.artefactMenu.IsOpen = true;
            //this.artefactTab.ContextMenu.IsOpen = true;
            ContextMenu dropArtifactMenu = this.Resources["dropArtifactMenu"] as ContextMenu;
            dropArtifactMenu.PlacementTarget = this.artefactTab;
            dropArtifactMenu.IsOpen = true;
        }

        private void artefactViewer_DragEnter(object sender, DragEventArgs e)
        {
            string[] formats = e.Data.GetFormats();
            foreach (string format in formats)
            {
                Console.WriteLine(format);
            }
            if (this.account.itemLoader.FindArtifactDropTarget(e.Data))
            {
                //Console.WriteLine("returned true");
                e.Effects = DragDropEffects.Copy;
            }
            else
            {
                //Console.WriteLine("returned false");
                e.Effects = DragDropEffects.None;
            }
        }

        private void artefactItemMenu_Click(object sender, RoutedEventArgs e)
        {
            MenuItem item = e.OriginalSource as MenuItem;
            Plugin artifactPlugin = item.Header as Plugin;
            //Console.WriteLine(artifactPlugin.name);
            AddArtifact(artifactPlugin, null);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Login(new LoginConf(serverBox.Text));
        }

        private void Expander_Expanded(object sender, RoutedEventArgs e)
        {
            directoryViewer.Height = peoplePanel.ActualHeight - 100;
        }

        private void addArtifactMenuItem_Click(object sender, RoutedEventArgs e)
        {
            MenuItem item = e.OriginalSource as MenuItem;
            Plugin artifactPlugin = item.Header as Plugin;
            AddArtifact(artifactPlugin, this.account.itemLoader.droppedData);
        }
    }
}
