﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows;
using System.Diagnostics;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Threading;
using System.ComponentModel;

namespace WebItem
{
    class WebBrowserOverlayWF
    {
        Window _owner;
        //WebBrowserItem _owner;
        //NativeWindow overlayOwner;
        FrameworkElement _placementTarget;
        Form _form; // the top-level window holding the WebBrowser control
        //WebBrowser _wb = new WebBrowser();
        WebBrowser _wb;
        public bool IsVisible;
        public bool IsSetInContainer;

        public WebBrowser WebBrowser { get { return _wb; } }

        /*public WebBrowserOverlayWF(FrameworkElement placementTarget, Window owner, double opacity)
        {
            _placementTarget = placementTarget;
            //Window owner = Window.GetWindow(placementTarget);
            Debug.Assert(owner != null);
            _owner = owner;

            _form = new Form();
            //_form.Opacity = owner.Opacity;
            _form.Opacity = opacity;
            _form.ShowInTaskbar = false;
            _form.FormBorderStyle = FormBorderStyle.None;
            _wb.Dock = DockStyle.Fill;
            _form.Controls.Add(_wb);

            //owner.SizeChanged += delegate { OnSizeLocationChanged(); };

            //owner.LocationChanged += delegate { OnSizeLocationChanged(); };
            owner.LocationChanged += new EventHandler(owner_LocationChanged);
            _placementTarget.SizeChanged += delegate { OnSizeLocationChanged(); };


            if (owner.IsVisible)
                InitialShow();
            else
                owner.SourceInitialized += delegate
                {
                    InitialShow();
                };

            //DependencyPropertyDescriptor dpd = DependencyPropertyDescriptor.FromProperty(UIElement.OpacityProperty, typeof(Window));
            //dpd.AddValueChanged(owner, delegate { _form.Opacity = _owner.Opacity; });

            _form.FormClosing += delegate { _owner.Close(); };
            //_form.Load += delegate { Reposition(); };
        }*/

        public WebBrowserOverlayWF(FrameworkElement placementTarget, WebBrowser wb)
        {
            //_wb = new WebBrowser();
            _wb = wb;
            _placementTarget = placementTarget;

            _form = new Form();
            _form.ShowInTaskbar = false;
            _form.FormBorderStyle = FormBorderStyle.None;
            _wb.Dock = DockStyle.Fill;
            _form.Controls.Add(_wb);

            _placementTarget.SizeChanged += delegate { OnSizeLocationChanged(); };

            //_form.FormClosing += delegate { _owner.Close(); };
            //overlayOwner = new NativeWindow();
            //overlayOwner.AssignHandle(((HwndSource)HwndSource.FromVisual(_owner)).Handle);
            _form.FormClosing += delegate { if (_owner != null) { _owner.Close(); } };
        }

        /*public void FirstShow(Window owner)
        {
            Debug.Assert(owner != null);
            _owner = owner;
            _form.Opacity = owner.Opacity;
            owner.LocationChanged += new EventHandler(owner_LocationChanged);
            if (owner.IsVisible)
                InitialShow();
            else
                owner.SourceInitialized += delegate
                {
                    InitialShow();
                };

        }*/

        void owner_LocationChanged(object sender, EventArgs e)
        {
            OnSizeLocationChanged();
            //throw new NotImplementedException();
        }

        void InitialShow()
        {
            NativeWindow owner = new NativeWindow();
            owner.AssignHandle(((HwndSource)HwndSource.FromVisual(_owner)).Handle);
            _form.Show(owner);
            Reposition();
            owner.ReleaseHandle();
            IsVisible = true;
        }

        DispatcherOperation _repositionCallback;

        void OnSizeLocationChanged()
        {
            // To reduce flicker when transparency is applied without DWM composition, 
            // do resizing at lower priority.
            if (_repositionCallback == null && _owner != null)
                _repositionCallback = _owner.Dispatcher.BeginInvoke(Reposition, DispatcherPriority.Input);
        }

        public void Reposition()
        {
            if (_owner == null || !_form.Visible)
            {
                return;
            }
            _repositionCallback = null;

            Point offset = _placementTarget.TranslatePoint(new Point(), _owner);
            Point size = new Point(_placementTarget.ActualWidth, _placementTarget.ActualHeight);
            HwndSource hwndSource = (HwndSource)HwndSource.FromVisual(_owner);
            CompositionTarget ct = hwndSource.CompositionTarget;
            offset = ct.TransformToDevice.Transform(offset);
            size = ct.TransformToDevice.Transform(size);

            Win32.POINT screenLocation = new Win32.POINT(offset);
            Win32.ClientToScreen(hwndSource.Handle, ref screenLocation);
            Win32.POINT screenSize = new Win32.POINT(size);

            Win32.MoveWindow(_form.Handle, screenLocation.X, screenLocation.Y, screenSize.X, screenSize.Y, true);
            //_form.SetBounds(screenLocation.X, screenLocation.Y, screenSize.X, screenSize.Y);
            //_form.Update();
        }

        public void Hide()
        {
            //_form.Visible = false;
            if (IsSetInContainer)
            {
                _form.Hide();
                IsVisible = false;
            }
            else
            {
                _form.Visible = false;
                IsVisible = false;
                
            }
        }

        public void Show()
        {
            //_form.Visible = true;
            if (IsSetInContainer)
            {
                _form.Show();
                IsVisible = true;
            }
            else
            {
                if (_owner.IsVisible)
                {
                    ShowAgain();
                }
                else
                    _owner.SourceInitialized += delegate
                    {
                        ShowAgain();
                    };
                
            }
        }

        void ShowAgain()
        {
            Console.WriteLine("show again");
            NativeWindow owner = new NativeWindow();
            owner.AssignHandle(((HwndSource)HwndSource.FromVisual(_owner)).Handle);

            _form.Show(owner);
            //Reposition();
            owner.ReleaseHandle();
            IsVisible = true;
            IsSetInContainer = true;
        }

        public void DetachFromContainer()
        {
            _owner.LocationChanged -= new EventHandler(owner_LocationChanged);
            _owner = null;
            IsSetInContainer = false;
            /*_form.Visible = false;
            _owner = null;
            IsVisible = false;*/
        }

        public void AttachToContainer(Window owner)
        {
            _owner = owner;
            _form.Opacity = owner.Opacity;
            owner.LocationChanged += new EventHandler(owner_LocationChanged);
            //IsSetInContainer = false;
            /*if (owner.IsVisible)
            {
                 ShowAgain();
            }
            else
                owner.SourceInitialized += delegate
                {
                    ShowAgain();
                };*/
        }

        /*public void UpdateOwner(Window owner)
        {
            _owner = owner;
        }*/

        public void Load(Window owner)
        {
            Debug.Assert(owner != null);
            _owner = owner;
            _form.Opacity = owner.Opacity;
            owner.LocationChanged += new EventHandler(owner_LocationChanged);
            if (owner.IsVisible)
                ShowForm();
            else
                owner.SourceInitialized += delegate
                {
                    ShowForm();
                };
        }

        public void ShowForm()
        {
            NativeWindow owner = new NativeWindow();
            owner.AssignHandle(((HwndSource)HwndSource.FromVisual(_owner)).Handle);
            _form.Show(owner);
            Reposition();
            owner.ReleaseHandle();
            IsVisible = true;
            IsSetInContainer = true;
        }

        public void UnLoad()
        {
            _owner.LocationChanged -= new EventHandler(owner_LocationChanged);
            _owner = null;
            _form.Visible = false;
            IsVisible = false;
            IsSetInContainer = false;
        }
    }
}
