﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MediaItemContract;
using System.Windows;
using System.Security.Policy;

namespace WebItem
{
    public class WebMediaItem:IArtifactItem
    {
        WebIconItem icon;
        WebThumbnailItem thumbnail;
        WebBrowserItem interactive;
        public WebPage webPage;

        public WebMediaItem()
        {

        }
        /*public WebItem(WebPage webPage)
        {
            this.webPage = webPage;
            icon = new WebIconItem();
            thumbnail = new WebThumbnailItem(webPage);
            //Console.WriteLine("before Nav");
            thumbnail.UpdateURL(webPage.url);
            //Console.WriteLine("after Nav");
            interactive = new WebBrowserItem(webPage);
            //Console.WriteLine("after interactive");
        }*/

        #region IMediaItem Members

        public System.Windows.Controls.UserControl GetIconItem()
        {
            return icon;
        }

        public System.Windows.Controls.UserControl GetThumbnailItem()
        {
            return thumbnail;
        }

        public System.Windows.Controls.UserControl GetInteractionItem()
        {
            return interactive;
        }

        public void ToBeDetachedFromContainer()
        {
            /*if (interactive.loadedInThisContainer)
            {
                interactive.DetachFromContainer();
            }*/
        }

        public void ToBeAttachedToOverlay()
        {

        }

        public void AttachedToOverlay()
        {
            /*if (interactive.loadedInThisContainer)
            {
                interactive.AttachToContainer();
            }*/
        }

        public void TeBeDetachedFromOverlay()
        {
            /*if (interactive.loadedInThisContainer)
            {
                interactive.DetachFromContainer();
            }*/
        }

        public void ToBeAttachedToContainer()
        {

        }

        public void AttachedToContainer()
        {
            /*if (interactive.loadedInThisContainer)
            {
                interactive.AttachToContainer();
            }*/
        }

        public void MovingInOverlay()
        {
            //interactive.Reposition();
        }

        public void LeaveInteractionMode()
        {

        }

        #endregion

        #region ICloneable Members

        public object Clone()
        {
            WebMediaItem item = new WebMediaItem();
            item.webPage = this.webPage;
            item.webPage.Initialize();
            item.icon = new WebIconItem();
            item.thumbnail = new WebThumbnailItem(webPage);
            item.thumbnail.UpdateURL(webPage.url);
            item.interactive = new WebBrowserItem(webPage);
            return item;
        }

        #endregion

        #region IArtifactItem Members

        public void StartItem(GroupLab.Networking.SharedDictionary sd, string path, object obj, IArtifact artifactHelper, IPerson personHelper)
        {
            this.webPage = new WebPage(sd, path, obj as string);
            this.webPage.Initialize();
            icon = new WebIconItem();
            thumbnail = new WebThumbnailItem(webPage);
            thumbnail.UpdateURL(webPage.url);
            interactive = new WebBrowserItem(webPage);
        }

        public void StopItem()
        {
            
        }

        #endregion

        #region IArtifactItem Members

        public static bool AcceptDropFormat(System.Windows.IDataObject data)
        {
            if (data.GetDataPresent(DataFormats.StringFormat))
            {
                string url = data.GetData(DataFormats.StringFormat) as string;
                if (url.StartsWith("http://"))
                {
                    return true;
                }
            }
            return false;
        }

        public void DropData(System.Windows.IDataObject data)
        {
            if (data.GetDataPresent(DataFormats.StringFormat))
            {
                string url = data.GetData(DataFormats.StringFormat) as string;
                Console.WriteLine("dropped url is "+url);
                this.webPage.Navigate(url);
            }
        }

        #endregion

        public static string ItemName
        {
            get { return "Web"; }
        }
    }
}
