﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GroupLab.Networking;
using System.Windows.Threading;
using MediaItemContract;

namespace WebItem
{
    public class WebPage: AbstractArtifact
    {
        public string url {set;get;}
        public string urlPath;
        Subscription urlSub;
        public event EventHandler newURL;
        //public delegate void NewURLDelegate();

        public WebPage(SharedDictionary sd, string path, string url)
            : base(sd, path)
        {
            this.url = url;
            if (this.url == null)
            {
                //this.url = "http://www.google.ca";
            }
            //this.urlSub = new Subscription();
            //this.urlSub.BeginInit();
            //this.urlSub.Dictionary = this.sd;
            //this.urlSub.Pattern = People.peoplePath + this.guid + "/image";
            //this.urlSub.Notified += new SubscriptionEventHandler(imageSub_Notified);
            //this.urlSub.EndInit();
        }

        /*public WebPage(string guid)
            : base(guid)
        {

        }*/

        public void Initialize()
        {
            //Console.WriteLine("initialize web page");
            this.urlPath = path + "/url";
            if (this.url != null)
            {
                this.sd[this.urlPath] = this.url;
            }
            this.urlSub = new Subscription();
            this.urlSub.BeginInit();
            this.urlSub.Dictionary = this.sd;
            this.urlSub.Pattern = this.urlPath;
            this.urlSub.Notified += new SubscriptionEventHandler(urlSub_Notified);
            this.urlSub.EndInit();
        }

        public void Navigate(string url)
        {
            if (this.url==url)
            {
                return;
            }
            this.url = url;
            this.sd[this.urlPath] = this.url;
            //Console.WriteLine("WebPage "+this.path+" Navigate " + url);
        }

        void urlSub_Notified(object sender, SubscriptionEventArgs e)
        {
            this.url = e.Value as string;
            //Console.WriteLine("WebPage " + this.path + " Notified " + url);
            OnPropertyChanged("url");
            if (newURL != null)
            {
                /*NewURLDelegate newURLdelegate = delegate
                {
                    Console.WriteLine("delegate called");
                    newURL(this, EventArgs.Empty);
                };
                Dispatcher.CurrentDispatcher.BeginInvoke(newURLdelegate, DispatcherPriority.Background);*/
                newURL(this, EventArgs.Empty);
            }
            else
            {
                //Console.WriteLine("newURL is null");
            }
        }
    }
}
