﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Drawing;


namespace WebItem
{
    /// <summary>
    /// Interaction logic for WebThumbnailItem.xaml
    /// </summary>
    public partial class WebThumbnailItem : UserControl
    {
        System.Windows.Forms.WebBrowser wb;
        WebPage webPage;
        public delegate void UpdateURLDelegate();

        public WebThumbnailItem(WebPage webPage)
        {
            InitializeComponent();
            this.image.Source = new BitmapImage(new Uri("images/web.png", UriKind.Relative));
            this.webPage = webPage;
            wb = new System.Windows.Forms.WebBrowser();
            wb.Width = 800;
            wb.Height = 800;
            wb.DocumentCompleted += new System.Windows.Forms.WebBrowserDocumentCompletedEventHandler(wb_DocumentCompleted);
            //Console.WriteLine("Add newURL in thumbnail");
            webPage.newURL += new EventHandler(webPage_newURL);
        }

        void webPage_newURL(object sender, EventArgs e)
        {
            //Console.WriteLine("thumbnail newURL");
            UpdateURLDelegate updateURLDelegate = delegate
            {
                UpdateURL(webPage.url);
            };
            Dispatcher.Invoke(updateURLDelegate);
            //UpdateURL(webPage.url);
        }

        void wb_DocumentCompleted(object sender, System.Windows.Forms.WebBrowserDocumentCompletedEventArgs e)
        {
           // Console.WriteLine("doc completed "+wb.Url);
            Bitmap docImage = new Bitmap(800, 800);
            wb.DrawToBitmap(docImage, new System.Drawing.Rectangle(0,
                    0, wb.Width, wb.Height));
            image.Source = loadBitmap(docImage);
            docImage.Dispose();
            //Console.WriteLine("web loaded");
        }

        public void UpdateURL(String url)
        {
            if (wb.Url == null || wb.Url.ToString() != webPage.url)
            {
                wb.Navigate(url);
            }
        }

        public BitmapSource loadBitmap(System.Drawing.Bitmap source)
        {
            IntPtr hBitmap = source.GetHbitmap();
            BitmapSource thumbnailSource = System.Windows.Interop.Imaging.CreateBitmapSourceFromHBitmap(hBitmap, IntPtr.Zero, Int32Rect.Empty,
                System.Windows.Media.Imaging.BitmapSizeOptions.FromEmptyOptions());
            DeleteObject(hBitmap);
            return thumbnailSource;
        }

        [System.Runtime.InteropServices.DllImport("gdi32.dll")]
        public static extern bool DeleteObject(IntPtr hObject);
    }
}
